#Get system compile config
SHELL_FOLDER=$(cd "$(dirname "$0")";pwd)
BSP_TOOLCHAIN_CMAKE_PATH=$1
export BSP_CBB_SO_OUTPUT_PATH=$2
[ -z "${BSP_TOOLCHAIN_CMAKE_PATH}" ] && echo "BSP build.sh,the first input para BSP_TOOLCHAIN_CMAKE_PATH is not set yet!!" && exit
[ -z "${BSP_CBB_SO_OUTPUT_PATH}" ] && echo "BSP build.sh,the first input para BSP_CBB_SO_OUTPUT_PATH is not set yet!!" && exit

export BSP_BUILD_PATH=${SHELL_FOLDER}
export BSP_INSTALL_PATH=${SHELL_FOLDER}/output/bin
export BSP_KO_PATH=${SHELL_FOLDER}/output/ko
export BSP_SO_PATH=${SHELL_FOLDER}/output/so
export BSP_A_PATH=${SHELL_FOLDER}/output/a
export BSP_INCLUDE_PATH=${SHELL_FOLDER}/output/bsp_h
export USP_INCLUDE_PATH=${SHELL_FOLDER}/output/usp_h

export BSP_DEPEND_USP_INCLUDE_PATH=${SHELL_FOLDER}/../../../enterprise_iplatform/usp/build/output/usp_h

export BSP_DEPEND_USP_SO_PATH=${SHELL_FOLDER}/../../../enterprise_iplatform/usp/build/output/usp_so
export BSP_DEPEND_USP_INSTALL_PATH=${SHELL_FOLDER}/../../../enterprise_iplatform/usp/build/output/usp_bin

if [ -f "./CMakeCache.txt" ]; then
rm CMakeCache.txt
else
echo "CMakeCache.txt not exist,no need to delete"
fi

if [ -d "${SHELL_FOLDER}/output" ]; then
rm -rf ${SHELL_FOLDER}/output
else
echo "BSP output not exist,no need to delete"
fi

if [ -d "${BSP_KO_PATH}" ]; then
echo "bsp ${BSP_KO_PATH} output directory exist"
else
mkdir -p ${BSP_KO_PATH}
fi
if [ -d "${BSP_SO_PATH}" ]; then
echo "bsp ${BSP_SO_PATH} output directory exist"
else
mkdir -p ${BSP_SO_PATH}
fi
if [ -d "${SHELL_FOLDER}/output/bin/" ]; then
echo "bsp .bin output directory exist"
else
mkdir -p ${SHELL_FOLDER}/output/bin/
fi
if [ -d "${BSP_A_PATH}" ]; then
echo "bsp ${BSP_A_PATH} output directory exist"
else
mkdir -p ${BSP_A_PATH}
fi

# Copy bsp's publich header file to bsp's ${BSP_INCLUDE_PATH} path
if [ -d "${BSP_INCLUDE_PATH}" ]; then
echo "bsp ${BSP_INCLUDE_PATH} output directory exist"
else
mkdir -p ${BSP_INCLUDE_PATH}
fi
if [ -d "${BSP_INCLUDE_PATH}/kernelh" ]; then
echo "bsp ${BSP_INCLUDE_PATH}/kernelh output directory exist"
else
mkdir -p ${BSP_INCLUDE_PATH}/kernelh/
fi
if [ -d "${BSP_INCLUDE_PATH}/userh" ]; then
echo "bsp ${BSP_INCLUDE_PATH}/userh output directory exist"
else
mkdir -p ${BSP_INCLUDE_PATH}/userh/
fi

# Copy bsp's publich header file to bsp's ${BSP_INCLUDE_PATH} path
if [ -d "${USP_INCLUDE_PATH}" ]; then
echo "bsp ${USP_INCLUDE_PATH} output directory exist"
else
mkdir -p ${USP_INCLUDE_PATH}
fi
if [ -d "${USP_INCLUDE_PATH}/kernelh" ]; then
echo "bsp ${USP_INCLUDE_PATH}/kernelh output directory exist"
else
mkdir -p ${USP_INCLUDE_PATH}/kernelh/
fi
if [ -d "${USP_INCLUDE_PATH}/userh" ]; then
echo "bsp ${USP_INCLUDE_PATH}/userh output directory exist"
else
mkdir -p ${USP_INCLUDE_PATH}/userh/
fi

cp -r -p ${BSP_DEPEND_USP_INCLUDE_PATH}/* ${USP_INCLUDE_PATH}

cp ${SHELL_FOLDER}/../code/*/pubh/*.h ${BSP_INCLUDE_PATH}
cp ${SHELL_FOLDER}/../code/type/pubh/kernelh/*.h ${BSP_INCLUDE_PATH}/kernelh/
cp ${SHELL_FOLDER}/../code/type/pubh/userh/*.h ${BSP_INCLUDE_PATH}/userh/
cp ${SHELL_FOLDER}/../code/hyperscan/lib/*.so ${BSP_SO_PATH}

# Compile
cmake ${SHELL_FOLDER}/../ -DCMAKE_TOOLCHAIN_FILE:FILEPATH=${BSP_TOOLCHAIN_CMAKE_PATH}
make -C ${SHELL_FOLDER}
