/*! Copyright(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
 *
 *\file		common_system.h
 *\brief	ad head file for config
 *\details	sw head file for config
 *
 *\author	marujun
 *\version	1.0
 *\date		20022-5-21
 *
 *\warning	
 *
 *\history \20022-5-21,	create file
 *						 
 */

/**************************************************************************************************/
/*                                      CONFIGURATIONS                                            */
/**************************************************************************************************/
#ifndef _AD_POE_COMMON_SYSTEM_H
#define _AD_POE_COMMON_SYSTEM_H

/**************************************************************************************************/
/*                                      INCLUDE_FILES                                             */
/**************************************************************************************************/
#include "usp_type.h"


/**************************************************************************************************/
/*                                      DEFINES                                                   */
/**************************************************************************************************/
#define IN    /* 标识入参 */
#define OUT   /* 标识出参 */

#ifndef STATUS_DEF
#define STATUS_DEF
typedef int                 STATUS;
#endif

#define 	ENABLE 		1
#define		DISABLE		0

#ifndef TRUE
#define TRUE   1
#endif
#ifndef FALSE
#define FALSE  0
#endif

#ifndef OK
#define OK		(0)
#endif

#ifndef ERROR
#define ERROR	(-1)
#endif

#ifndef BOOL_DEF
#define BOOL_DEF
typedef int					BOOL;
#endif


#define DBG_CONTROL DISABLE

#if DBG_CONTROL == ENABLE
#define DBG_VERBOSE(fmt, param...) do{printf("[%s():%d] "fmt, __FUNCTION__,__LINE__,##param);}while(0)
#define DBG(fmt...) do{printf(fmt);}while(0)
#else
#define DBG_VERBOSE(fmt, param...) 
#define DBG(fmt...) 
#endif

typedef enum{
    AD_MARVELL_ER7212PC = 0,

}MODEL_INFO;

typedef	enum
{
	
		ERR_NO_ERROR = 0,						// No Error. Note: OK is defined in Vx_work.
		
		ERR_BAD_PARAM,							// Bad parameter, special aim at pointer is NULL

		ERR_CONFIG_WRITE_PROFILE,

		ERR_HW_OP_FAIL,

		ERR_NO_MEMORY,

		ERR_I2C_WRITE,
		
		ERR_PORT_ID_OUTOF_RANGE,

		ERR_THE_END,
} BSP_ERROR_CODE;

typedef enum{
	PSE_CHIP_TYPE_TPS23861 = 0,
	PSE_CHIP_TYPE_TPS23881 = 1,
	PSE_CHIP_TYPE_TPS23882 = 2,
	PSE_CHIP_TYPE_XS2184 = 3,
	PSE_CHIP_TYPE_MP3924 = 4,
	PSE_CHIP_TYPE_END
}PSE_CHIP_TYPE_ENUM;

/**************************************************************************************************/
/*                                      VARIABLES                                                 */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      FUNCTIONS                                                 */
/**************************************************************************************************/

MODEL_INFO get_model_info();
int get_port_number(void);
usp_uint32_t get_poe_first_uport(void);
usp_uint32_t get_poe_last_uport(void);
usp_uint32_t get_poe_power_min(void);
usp_uint32_t get_poe_power_limit(void);
usp_uint32_t get_poe_float_power(void);
usp_uint32_t get_poe_port_num(void);
usp_uint32_t get_poe_first_uport(void);
usp_uint32_t get_poe_last_uport(void);
usp_uint32_t get_include_poe_power_on_manage(void);
usp_uint32_t get_poe_port_default_priority(void);
usp_uint32_t get_poe_power_limit_per_port(void);
usp_uint32_t get_poe_fan_state(void);

#endif