/*! Copyright(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
 *
 *\file		gpio.h
 *\brief	gpio get and set 
 *\details	gpio get and set 
 *
 *\author	marujun
 *\version	1.0
 *\date		20022-5-21
 *
 *\warning	
 *
 *\history \20022-5-21,	create file
 *						 
 */
/**************************************************************************************************/
/*                                      CONFIGURATIONS                                            */
/**************************************************************************************************/
#ifndef _AD_BSP_GPIO_H
#define _AD_BSP_GPIO_H

/**************************************************************************************************/
/*                                      INCLUDE_FILES                                             */
/**************************************************************************************************/
#include "common_sys.h"

/**************************************************************************************************/
/*                                      DEFINES                                                   */
/**************************************************************************************************/

typedef enum{
	PIN_TYPE_GPIO = 0,/*Common GPIO in MPPs*/
	PIN_TYPE_SERIAL = 1,/*GPO PIN or LED driven by serial LED Controller*/
	PIN_TYPE_GPP = 2, /*GPIO in GPPs*/
	PIN_TYPE_MAC_GPIO = 3, /*GPIO in MAC*/
	PIN_TYPE_EXT_MCU = 4, /*HW CTRL*/
	PIN_TYPE_END
}GPIO_PIN_TYPE_ENUM;

#define GPIO_DIRECTION_INPUT 0
#define GPIO_DIRECTION_OUTPUT 1
#define GPIO_FNAME_LEN 64

typedef struct {
	usp_uint8_t type;
	usp_uint8_t pin;
	usp_uint8_t invrt;/*1: low Voltage to enlight 0:high Voltage to enlight*/
}GPIO_CTRL_STRUCT;

/**************************************************************************************************/
/*                                      VARIABLES                                                 */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      FUNCTIONS                                                 */
/**************************************************************************************************/

int ad_misc_gpio_init(usp_uint8_t unit, usp_uint8_t gpio);
int ad_misc_gpio_de_init(usp_uint8_t unit, usp_uint8_t gpio);
int ad_misc_gpio_dir_set(usp_uint8_t unit, usp_uint8_t gpio, usp_uint8_t dir, usp_uint val);
int ad_misc_gpio_set(usp_uint8_t unit, usp_uint8_t flag, usp_uint8_t gpio, usp_uint enable);

#endif