/*! Copyright(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
 *
 *\file		i2c.h
 *\brief	i2c get and set 
 *\details	i2c get and set 
 *
 *\author	marujun
 *\version	1.0
 *\date		20022-5-21
 *
 *\warning	
 *
 *\history \20022-5-21,	create file
 *						 
 */
/**************************************************************************************************/
/*                                      CONFIGURATIONS                                            */
/**************************************************************************************************/
#ifndef _AD_BSP_I2C_H
#define _AD_BSP_I2C_H

/**************************************************************************************************/
/*                                      INCLUDE_FILES                                             */
/**************************************************************************************************/
#include "common_sys.h"

/**************************************************************************************************/
/*                                      DEFINES                                                   */
/**************************************************************************************************/

typedef enum
{
	I2C_TYPE_STD = 0,
	I2C_TYPE_GPIO = 1,
	I2C_TYPE_GPIO2 = 2,
	I2C_TYPE_GPIO3 = 3,
	I2C_TYPE_END,
}I2C_TYPE_ENUM;


/**************************************************************************************************/
/*                                      VARIABLES                                                 */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      FUNCTIONS                                                 */
/**************************************************************************************************/
int ad_i2c_init(void);
int ad_misc_i2c_data_get(usp_uint8_t i2c_id, usp_uint8_t addr, usp_uint32_t offset, usp_uint32_t buff_size, OUT usp_uint8_t *buff);
int ad_misc_i2c_data_set(usp_uint8_t i2c_id, usp_uint8_t addr, usp_uint32_t offset, usp_uint32_t buff_size, usp_uint8_t *buff);

#endif