/*
 * $Id: thread.h 1.13 Broadcom SDK $
 * $Copyright: Copyright 2012 Broadcom Corporation.
 * This program is the proprietary software of Broadcom Corporation
 * and/or its licensors, and may only be used, duplicated, modified
 * or distributed pursuant to the terms and conditions of a separate,
 * written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized
 * License, Broadcom grants no license (express or implied), right
 * to use, or waiver of any kind with respect to the Software, and
 * Broadcom expressly reserves all rights in and to the Software
 * and all intellectual property rights therein.  IF YOU HAVE
 * NO AUTHORIZED LICENSE, THEN YOU HAVE NO RIGHT TO USE THIS SOFTWARE
 * IN ANY WAY, AND SHOULD IMMEDIATELY NOTIFY BROADCOM AND DISCONTINUE
 * ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization,
 * constitutes the valuable trade secrets of Broadcom, and you shall use
 * all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of
 * Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS
 * PROVIDED "AS IS" AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES,
 * REPRESENTATIONS OR WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY,
 * OR OTHERWISE, WITH RESPECT TO THE SOFTWARE.  BROADCOM SPECIFICALLY
 * DISCLAIMS ANY AND ALL IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
 * NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, LACK OF VIRUSES,
 * ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION OR
 * CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING
 * OUT OF USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL
 * BROADCOM OR ITS LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL,
 * INCIDENTAL, SPECIAL, INDIRECT, OR EXEMPLARY DAMAGES WHATSOEVER
 * ARISING OUT OF OR IN ANY WAY RELATING TO YOUR USE OF OR INABILITY
 * TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF
 * THE AMOUNT ACTUALLY PAID FOR THE SOFTWARE ITSELF OR USD 1.00,
 * WHICHEVER IS GREATER. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING
 * ANY FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY.$
 *
 * File: 	thread.h
 * Purpose: 	PAL thread definitions
 */

#ifndef _PAL_THREAD_H
#define _PAL_THREAD_H

//#include <sdk_config.h>

typedef struct pal_thread_s{
    char thread_opaque_type;
} *pal_thread_t;

#define PAL_THREAD_ERROR	((pal_thread_t) -1)
#ifndef PAL_THREAD_STKSZ
#define	PAL_THREAD_STKSZ	16384	/* Default Stack Size */
#endif

#define PAL_THREAD_NAME_MAX_LEN     80 

extern void
pal_thread_resource_usage_get(unsigned int *pal_thread_count_curr,
                              unsigned int *pal_stack_size_curr,
                              unsigned int *pal_thread_count_max,
                              unsigned int *pal_stack_size_max);

extern pal_thread_t pal_thread_create(const char *, int, int, 
				  void (f)(void *), void *);
extern int pal_thread_destroy(pal_thread_t);
extern pal_thread_t pal_thread_self(void);
extern char* pal_thread_name(pal_thread_t thread,
				 char *thread_name, int thread_name_size);
extern void pal_thread_exit(int);
extern void pal_thread_yield(void);
extern void pal_thread_main_set(pal_thread_t thread);
extern pal_thread_t pal_thread_main_get(void);


#define pal_msleep(x)    pal_usleep((x) * 1000)
extern void pal_sleep(int sec);
extern void pal_usleep(unsigned int usec);
extern void pal_udelay(unsigned int usec);
extern void
pal_thread_resource_usage_get(
                unsigned int *pal_thread_count_curr,
                unsigned int *pal_stack_size_curr,
                unsigned int *pal_thread_count_max,
                unsigned int *pal_stack_size_max);

typedef void pal_tls_key_t;

extern pal_tls_key_t * pal_tls_key_create(void (*destructor)(void *));
extern int pal_tls_key_set(pal_tls_key_t *, void *);
extern void * pal_tls_key_get(pal_tls_key_t *);
extern int pal_tls_key_delete(pal_tls_key_t *);

#endif	/* !_PAL_THREAD_H */
