/*! Copyright(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
 *
 *\file		ad_poe_misc.h
 *\brief	ad head file for poe misc
 *\details	sw head file for poe misc
 *
 *\author	Cui_binglin
 *\version	1.0
 *\date		2015-01-06
 *
 *\warning	
 *
 *\history \2015-01-06,	create file
 *						 
 */


/**************************************************************************************************/
/*                                      CONFIGURATIONS                                            */
/**************************************************************************************************/
#ifndef _AD_POE_MISC_H
#define _AD_POE_MISC_H

/**************************************************************************************************/
/*                                      INCLUDE_FILES                                             */
/**************************************************************************************************/
#include "ad_poe_config.h"


/**************************************************************************************************/
/*                                      DEFINES                                                   */
/**************************************************************************************************/
typedef struct {
	usp_uint8_t g_led_type;/*LED_TYPE_CLASS or LED_TYPE_GROUP for green*/
	usp_uint8_t y_led_type;/*LED_TYPE_CLASS or LED_TYPE_GROUP for yellow*/
	//CPSS_DXCH_LED_PORT_TYPE_ENT led_port_type;
	usp_uint8_t led_interface;/*LED0 or LED1*/
	/*led class select among 0-13 pre-defined classes or group select among 0-3 group: 0xF for NOT_USE*/
	/*GREEN led selection*/
	usp_uint8_t sel_green;
	/*led class select among 0-13 pre-defined classes or group select among 0-3 group: 0xF for NOT_USE*/
	/*YELLOW led selection*/
	usp_uint8_t sel_yellow;
	usp_uint8_t g_port_num;/*green led port num*/
	usp_uint8_t y_port_num;/*yellow led port num*/
}LED_CTRL_STRUCT;

typedef struct {
	usp_uint8_t index;
	usp_uint8_t offset;
	usp_uint8_t len;
	usp_uint8_t val[POE_LED_STATE_END];
}MCU_CTRL_STRUCT;


/**************************************************************************************************/
/*                                      VARIABLES                                                 */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      FUNCTIONS                                                 */
/**************************************************************************************************/
int ad_poe_misc_init();
int ad_poe_board_init(void);

int ad_poe_bus_probe(unsigned char reg_addr);

int ad_poe_chip_reset(void);
void ad_poe_board_reset(void);

void ad_led_poe_max_led_off(void);
void ad_led_poe_max_led_green_on(void);
void ad_led_poe_max_led_green_blink(void);

//int ad_poe_led_ctrl(int enable);

int ad_poe_bus_init(void);
int ad_poe_bus_reset();
int ad_poe_bus_write(unsigned int offset,unsigned char *buffer,unsigned int length);
int ad_poe_bus_read(unsigned int offset, unsigned char *buffer, unsigned int *length);

#endif