/***********************************************************************
* Copyright (c) 2007-2014 TP-Link Technologies CO.,LTD.
* All rights reserved.
* 
* File Name	    	: mp3924.h
* Version		    	: V1.0
* Description		: MP3924芯片相关头文件
*
* Author			: zengjunjun
* Date		    	: 2015-04-22
*
* History			: 2015-04-22, zengjunjun, create the file
***********************************************************************/
#ifndef _MP3924_H_
#define _MP3924_H_

#define MP3924_POE_INTERRUPT_MASK						 0x01
#define MP3924_POE_OPERATION_MODE_SETING				 0x03
#define MP3924_POE_PORT_ENABLE							 0x05
#define MP3924_POE_DET_CLS_ENABLE						 0x06
#define MP3924_POE_DISCONNECT_ENABLE					 0x07
#define MP3924_POE_2EVENT_AND_CLASS5_ENABLE			 0x0C
#define MP3924_POE_GENERAL_ENABLE_CONTROL				 0x0F
#define MP3924_POE_POWER_STATUS						 0x2A
#define MP3924_POE_PMAX_POWER_SETTING_MSB				 0x55
#define MP3924_POE_PMAX_POWER_SETTING_LSB				 0x54
#define MP3924_POE_OVER_LOAD_STATUS_CLEAR				 0x2E
#define MP3924_POE_CURRENT_LIMIT_STATUS_CLEAR			 0x30
#define MP3924_POE_DISCONNECT_STATUS_CLEAR				 0x32
#define MP3924_POE_POWER_SOURCE_STATUS1			 	 0x20
#define MP3924_POE_POWER_SOURCE_STATUS1_CLEAR			 0x21
#define MP3924_POE_POWER_EVENT_CLEAR 0x2C
#define MP3924_POWER_ON_OFF_TRIGGER_COMMAND 0x11


#define MP3924_POE_ICUT1_THRESHOLD						 0x13
#define MP3924_POE_ICUT2_THRESHOLD						 0x14
#define MP3924_POE_ICUT3_THRESHOLD						 0x15
#define MP3924_POE_ICUT4_THRESHOLD						 0x16

#define MP3924_POE_ICUT_THRESHOLD(PORTNUM)				 (MP3924_POE_ICUT1_THRESHOLD + PORTNUM)
#define MP3924_POE_ILIM1_THRESHOLD						 0x17
#define MP3924_POE_ILIM2_THRESHOLD						 0x18
#define MP3924_POE_ILIM3_THRESHOLD						 0x19
#define MP3924_POE_ILIM4_THRESHOLD						 0x1A

#define MP3924_POE_ILIM_THRESHOLD(PORTNUM)				 (MP3924_POE_ILIM1_THRESHOLD + PORTNUM)

#define MP3924_POE_PORT_1_CURRENT_MSB					 0x41
#define MP3924_POE_PORT_1_CURRENT_LSB					 0x40
#define MP3924_POE_PORT_2_CURRENT_MSB					 0x45
#define MP3924_POE_PORT_2_CURRENT_LSB					 0x44
#define MP3924_POE_PORT_3_CURRENT_MSB					 0x49
#define MP3924_POE_PORT_3_CURRENT_LSB					 0x48
#define MP3924_POE_PORT_4_CURRENT_MSB					 0x4D
#define MP3924_POE_PORT_4_CURRENT_LSB					 0x4C




#define MP3924_POE_PORT_CURRENT_MSB(PORTNUM)			 (MP3924_POE_PORT_1_CURRENT_MSB + (PORTNUM << 2))				  /* PORT0对应DATASHEET的PORT1 */
#define MP3924_POE_PORT_CURRENT_LSB(PORTNUM)			 (MP3924_POE_PORT_1_CURRENT_LSB + (PORTNUM << 2))

#define MP3924_POE_OUT_1_VOLTAGE_MSB					 0x43
#define MP3924_POE_OUT_1_VOLTAGE_LSB					 0x42
#define MP3924_POE_OUT_2_VOLTAGE_MSB					 0x47
#define MP3924_POE_OUT_2_VOLTAGE_LSB					 0x46
#define MP3924_POE_OUT_3_VOLTAGE_MSB					 0x4B
#define MP3924_POE_OUT_3_VOLTAGE_LSB					 0x4A
#define MP3924_POE_OUT_4_VOLTAGE_MSB					 0x4F
#define MP3924_POE_OUT_4_VOLTAGE_LSB					 0x4E


#define MP3924_POE_OUT_VOLTAGE_MSB(PORTNUM)			 (MP3924_POE_OUT_1_VOLTAGE_MSB + (PORTNUM << 2))				  /* PORT0对应DATASHEET的PORT1 */
#define MP3924_POE_OUT_VOLTAGE_LSB(PORTNUM)			 (MP3924_POE_OUT_1_VOLTAGE_LSB + (PORTNUM << 2))
#define MP3924_POE_INPUT_VOLTAGE_MSB					 0x51
#define MP3924_POE_INPUT_VOLTAGE_LSB					 0x50

#define MP3924_POE_PMAXEN_OFFSET						 2
#define MP3924_POE_PMAXEN_MASK							 0x1

#define MP3924_POE_PG1_OFFSET							 4
#define MP3924_POE_PG1_MASK							 0x10
#define MP3924_POE_PG_OFFSET(PORTNUM)					 (PORTNUM + MP3924_POE_PG1_OFFSET)			  				 	/* PORT0对应DATASHEET的PG1 */
#define MP3924_POE_PG_MASK(PORTNUM)                     (MP3924_POE_PG1_MASK << PORTNUM)

#define MP3924_SHUTDOWN_MODE							 0x00
#define MP3924_MANUAL_MODE								 0x55
#define MP3924_SEMI_AUTO_MODE							 0xAA
#define MP3924_AUTO_MODE								 0xFF

#define MP3924_DETECTION_EVENT_CLEAR_COMMAND 0x25
#define MP3924_CHANNEL_1_STATUS_COMMAND 0x26
#define MP3924_CHANNEL_2_STATUS_COMMAND 0x27
#define MP3924_CHANNEL_3_STATUS_COMMAND 0x28
#define MP3924_CHANNEL_4_STATUS_COMMAND 0x29

#define POE_PORT_SINGLE_LINE 	1
#define POE_PORT_DUAL_LINE		2




#define MP3924_PSE_I_UNIT (2.4) /* unit:m_a */
#define MP3924_PSE_V_UNIT (150) /* unit:m_v */

#define MP3924_PSE_I_OFFSET (10) /* unit:m_a */

#define MP3924_AVERRAGE_Current_and_Voltage 8


#endif /* _TPS23861_H_ */

