/*******************************************************************************
 *
 * Copyright (c) 2008 TP-Link Technologies CO.,LTD.
 * All rights reserved.
  
 * Filename:		sw_timer.h
 * Version:			1.0
 * Abstract:		
 *
 * Author:			郑星固 <zhengxinggu@tp-link.net>
 * Created Date:	02/16/2008
 *
 * Modified History:	
 *
 *
 *******************************************************************************/
#ifndef _TIMER_H_
#define _TIMER_H_

#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "usp_type.h"
#include "ad_poe_config.h"



#define TIMER_ID				int
#define TIMER_STYLE				int
#define EXECUTE_FOREVER			-1
#define EXECUTE_SINGLE			1

#define MAX_TIMER_NUMBER		64
#define TIMER_TASK_PRIORITY		51	
								/*!<将TIMER任务由48优先级降至51，防止跟NETTASK进行不必要的任务调度 48  (add by Cai Peifeng:2010-11-16 16:52:34) */

struct timer_task
{	
	struct  timespec expires;					// 用于记录定时任务到期的系统时间
	struct  timespec interval;					// 用于记录期望定时器执行的时间间隔
	void (*p_function)(usp_uint);		// 当定时时间到时所执行的回调函数
	usp_uint param;						// 回调函数的参数
	TIMER_STYLE style;				// 任务执行类型
};
struct timer_list
{
	struct timer_task task;			// 定时任务结点
	struct timer_list *prior;		// 前一结点指针
	struct timer_list *next;		// 后一结点指针
};

STATUS timer_init(void);
TIMER_ID add_timer(struct timespec * p_time_interval, void *p_function, usp_uint param, TIMER_STYLE style);
STATUS del_timer(usp_uint n_timer_ID);

/* 函数名称	: timer_clear
 * 函数介绍	: 清空定时器列表
 * 输入参数	: 无
 * 输出参数	: 无
 * 返 回 值	: 无
 */
void timer_clear();


#endif // _SWTIMER_H_
