#!/bin/sh /etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     nat.init
# brief
# author   Chen chen
# version  1.0.0
# date     05June15
# histry   arg 1.0.0, 05June15, Chen chen, Create the file.

. /lib/zone/zone_api.sh
. /lib/functions/network.sh
. /lib/functions/special_config.sh

fw_load_vpn()
{	
	local IPT_RESTORE="iptables-restore -w -n"
	FW_VPN_MONGLE_RULE="/tmp/.fw_vpn_mangle_rule"
	FW_VPN_FILTER_RULE="/tmp/.fw_vpn_filter_rule"
	FW_VPN_NAT_RULE="/tmp/.fw_vpn_nat_rule"
	FW_VPN_RAW_RULE="/tmp/.fw_vpn_raw_rule"
	echo "*mangle" > $FW_VPN_MONGLE_RULE
	echo "*filter" > $FW_VPN_FILTER_RULE
	echo "*nat" > $FW_VPN_NAT_RULE
	echo "*raw" > $FW_VPN_RAW_RULE
	#l2tp hnat mark rule
	echo "-I PREROUTING 1 -p udp --dport 1701 -j EXTMARK --or-mark 0x4" >> $FW_VPN_MONGLE_RULE
	echo "-I PREROUTING 1 -p udp --sport 1701 -j EXTMARK --or-mark 0x4" >> $FW_VPN_MONGLE_RULE
	echo "-I OUTPUT 1 -p udp --dport 1701 -j EXTMARK --or-mark 0x4" >> $FW_VPN_MONGLE_RULE
	echo "-I OUTPUT 1 -p udp --sport 1701 -j EXTMARK --or-mark 0x4" >> $FW_VPN_MONGLE_RULE

	# load ipsec and l2tp
	echo "-N ipsec_forward_rule" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule -j ipsec_forward_rule" >> $FW_VPN_FILTER_RULE

	# used for l2tp and pptp vpn
	echo "-N ppp_forward_rule" >> $FW_VPN_FILTER_RULE
	echo "-N ppp_input_rule" >> $FW_VPN_FILTER_RULE
	echo "-N ppp_input_rule_pre" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule -j ppp_forward_rule" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule -j ppp_input_rule" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule_pre -j ppp_input_rule_pre" >> $FW_VPN_FILTER_RULE

	echo "-N ppp_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-N ppp_service_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j ppp_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-A POSTROUTING -j ppp_service_rule" >> $FW_VPN_NAT_RULE

	# used for gre vpn
	echo "-N gre_forward_rule" >> $FW_VPN_FILTER_RULE
	echo "-N gre_input_rule" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule -j gre_forward_rule" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule -j gre_input_rule" >> $FW_VPN_FILTER_RULE

	echo "-N local_service_rule" >> $FW_VPN_FILTER_RULE
	echo "-A local_service_rule -p esp -j ACCEPT" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule -j local_service_rule" >> $FW_VPN_FILTER_RULE

	echo "-A INPUT -m policy --dir in --pol ipsec --proto ah  -j ipsecmark" >> $FW_VPN_MONGLE_RULE
	echo "-A INPUT -m policy --dir in --pol ipsec --proto esp -j ipsecmark" >> $FW_VPN_MONGLE_RULE

	echo "-N zone_vpn_forward" >> $FW_VPN_FILTER_RULE
	echo "-A forward -j zone_vpn_forward" >> $FW_VPN_FILTER_RULE

	echo "-N gre_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-N gre_service_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j gre_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-A POSTROUTING -j gre_service_rule" >> $FW_VPN_NAT_RULE

	#used for sslvpn resource acl rules
	echo "-N sslvpn_resource_acl" >> $FW_VPN_FILTER_RULE
	echo "-N sslvpn_resource_acl_pre" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule  -j sslvpn_resource_acl" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule_pre  -j sslvpn_resource_acl_pre" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule   -j sslvpn_resource_acl" >> $FW_VPN_FILTER_RULE

	#used for openvpn
	#bind when wan create
	echo "-N zone_wan_openvpn" >> $FW_VPN_FILTER_RULE

	echo "-N openvpn_forwarding_rule" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule -j openvpn_forwarding_rule" >> $FW_VPN_FILTER_RULE

	echo "-N openvpn_input_rule" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule -j openvpn_input_rule" >> $FW_VPN_FILTER_RULE

	echo "-N openvpn_prerouting_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j openvpn_prerouting_rule" >> $FW_VPN_NAT_RULE

	echo "-N openvpn_postrouting_rule" >> $FW_VPN_NAT_RULE
	echo "-I POSTROUTING -j openvpn_postrouting_rule" >> $FW_VPN_NAT_RULE

	echo "-N openvpn_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-N openvpn_service_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j openvpn_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-A POSTROUTING -j openvpn_service_rule" >> $FW_VPN_NAT_RULE

	#used for wireguard
	echo "-N wireguard_forwarding_rule" >> $FW_VPN_FILTER_RULE
	echo "-A forwarding_rule -j wireguard_forwarding_rule" >> $FW_VPN_FILTER_RULE

	echo "-N wireguard_prerouting_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j wireguard_prerouting_rule" >> $FW_VPN_NAT_RULE

	echo "-N wireguard_postrouting_rule" >> $FW_VPN_NAT_RULE

	echo "-N wireguard_input_rule" >> $FW_VPN_FILTER_RULE
	echo "-A input_rule -j wireguard_input_rule" >> $FW_VPN_FILTER_RULE

	echo "-N wireguard_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-N wireguard_service_rule" >> $FW_VPN_NAT_RULE
	echo "-A PREROUTING -j wireguard_preservice_rule" >> $FW_VPN_RAW_RULE
	echo "-A POSTROUTING -j wireguard_service_rule" >> $FW_VPN_NAT_RULE
	
	#set forwarding mark for vpn/ip rule: 0x20000
	echo "-N VPN_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A PREROUTING -j VPN_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-N VPN_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-N VPN_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A VPN_FORWARD_RULE -j VPN_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A FORWARD -j VPN_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A VPN_FORWARD_RULE -m mark --mark 0x20000/0x20000 -j RETURN" >> $FW_VPN_MONGLE_RULE
	echo "-N VPN_INPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A INPUT -j VPN_INPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-N VPN_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A OUTPUT -j VPN_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE

	#set forwarding mark for openvpn/ip rule: 0x20000
	echo "-N OPENVPN_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A PREROUTING -j OPENVPN_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-N OPENVPN_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-N OPENVPN_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A OPENVPN_FORWARD_RULE -j OPENVPN_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A FORWARD -j OPENVPN_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A OPENVPN_FORWARD_RULE -m mark --mark 0x20000/0x20000 -j RETURN" >> $FW_VPN_MONGLE_RULE

	#set forwarding mark for wireguard/ip rule: 0x20000
	echo "-N WIREGUARD_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A PREROUTING -j WIREGUARD_FORWARD_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-N WIREGUARD_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-N WIREGUARD_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A WIREGUARD_FORWARD_RULE -j WIREGUARD_FORWARD_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A FORWARD -j WIREGUARD_ROUTING_MARK" >> $FW_VPN_MONGLE_RULE
	echo "-A WIREGUARD_FORWARD_RULE -m mark --mark 0x20000/0x20000 -j RETURN" >> $FW_VPN_MONGLE_RULE

	#set wireguard output rule 
	echo "-N WIREGUARD_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A OUTPUT -j WIREGUARD_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-I OUTPUT -m conntrack --ctdir ORIGINAL -m set --match-set IPGROUP_LAN dst  -m comment --comment \"for ldap in full mode\" -j MARK --set-mark 0x0/0x20000" >> $FW_VPN_MONGLE_RULE

	#set openvpn output rule
	echo "-N OPENVPN_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE
	echo "-A OUTPUT -j OPENVPN_OUTPUT_RULE" >> $FW_VPN_MONGLE_RULE
	
	#for dmz bypass rule
	echo "-N dmz_prerouting_rule" >> $FW_VPN_NAT_RULE
	echo "COMMIT" >> $FW_VPN_MONGLE_RULE
        $IPT_RESTORE < $FW_VPN_MONGLE_RULE
	echo "COMMIT" >> $FW_VPN_FILTER_RULE
        $IPT_RESTORE < $FW_VPN_FILTER_RULE
	echo "COMMIT" >> $FW_VPN_NAT_RULE
        $IPT_RESTORE < $FW_VPN_NAT_RULE
	echo "COMMIT" >> $FW_VPN_RAW_RULE
        $IPT_RESTORE < $FW_VPN_RAW_RULE
}

fw_load_manage_vlan()
{
	local mvlan=$(uci get network.lan.manage_vid)

	config_load remote_mngt
	set_mngt_vlan() {
		local iface=$(uci get remote_mngt.$1.iface)
		[ "$iface" = "lan" ] && {
			local vlan=$(uci get remote_mngt.$1.mvlan)
			[ "$vlan" != "$2" ] && {
				uci set remote_mngt.$1.mvlan=$2
				uci commit
			}
		}
	}

	[ -n "$mvlan" -a "$(vlanctrl vlan_dump ${mvlan})" = "{}" ]  && mvlan=""

	config_foreach set_mngt_vlan mngt_iface "$mvlan"

	/etc/init.d/remote_mngt restart
}

fw_load_sfe()
{
	if ! iptables -w -t mangle -C sfe_mark -j CONNEXTMARK --set-mark 0x8/0x8 2>/dev/null; then
		iptables -w -t mangle -N sfe_mark
		iptables -w -t mangle -A sfe_mark -j EXTMARK --or-mark 0x8
		iptables -w -t mangle -A sfe_mark -m connextmark --mark 0x8/0x8 -j RETURN
		iptables -w -t mangle -A sfe_mark -j CONNEXTMARK --set-mark 0x8/0x8 
	fi
	if ! iptables -w -t mangle -C hwnat_mark -j CONNEXTMARK --set-mark 0x4/0x4 2>/dev/null; then
		iptables -w -t mangle -N hwnat_mark
		iptables -w -t mangle -A hwnat_mark -j EXTMARK --or-mark 0x4
		iptables -w -t mangle -A hwnat_mark -m connextmark --mark 0x4/0x4 -j RETURN
		iptables -w -t mangle -A hwnat_mark -j CONNEXTMARK --set-mark 0x4/0x4 
		iptables -w -t mangle -I sfe_mark 1 -j hwnat_mark
	fi
	iptables -w -t mangle -I FORWARD 1 -j CONNEXTMARK --set-mark 0x0/0xc

        if ! ip6tables -w -t mangle -C sfe_mark -j CONNEXTMARK --set-mark 0x8/0x8 2>/dev/null; then
                ip6tables -w -t mangle -N sfe_mark
                ip6tables -w -t mangle -A sfe_mark -j EXTMARK --or-mark 0x8
                ip6tables -w -t mangle -A sfe_mark -m connextmark --mark 0x8/0x8 -j RETURN
                ip6tables -w -t mangle -A sfe_mark -j CONNEXTMARK --set-mark 0x8/0x8
        fi
        if ! ip6tables -w -t mangle -C hwnat_mark -j CONNEXTMARK --set-mark 0x4/0x4 2>/dev/null; then
                ip6tables -w -t mangle -N hwnat_mark
                ip6tables -w -t mangle -A hwnat_mark -j EXTMARK --or-mark 0x4
                ip6tables -w -t mangle -A hwnat_mark -m connextmark --mark 0x4/0x4 -j RETURN
                ip6tables -w -t mangle -A hwnat_mark -j CONNEXTMARK --set-mark 0x4/0x4
                ip6tables -w -t mangle -I sfe_mark 1 -j hwnat_mark
        fi
        ip6tables -w -t mangle -I FORWARD 1 -j CONNEXTMARK --set-mark 0x0/0xc
}

MANAGE_DEVS_LOCK=/tmp/.manage_devs.lock

fw_add_passthrough_manage_devs()
{
	local manage_devs_chain="manage_devs"

	{
		flock -x 63
		iptables -w -I ${manage_devs_chain} 1 $@ -j RETURN
		flock -u 63
	} 63<>${MANAGE_DEVS_LOCK}
}

fw_del_passthrough_manage_devs()
{
	local manage_devs_chain="manage_devs"

	{
		flock -x 63
		iptables -w -D ${manage_devs_chain} $@ -j RETURN
		flock -u 63
	} 63<>${MANAGE_DEVS_LOCK}
}

fw_del_passthrough_manage_devs_by_label()
{
	local manage_devs_chain="manage_devs"
	local label1="$1"
	local label2="$2"
	local nums=""

	{
		flock -x 63

		nums=$(iptables -w -vnL ${manage_devs_chain} --line-numbers | grep "\b${label1}\b" | grep "\b${label2}\b" | cut -d ' ' -f 1)
		while [ -n "${nums}" ]; do
			for num in $nums;
			do
				iptables -w -D ${manage_devs_chain} ${num}
				break; # just delete the first once.
			done
			nums=$(iptables -w -vnL ${manage_devs_chain} --line-numbers | grep "\b${label1}\b" | grep "\b${label2}\b" | cut -d ' ' -f 1)
		done
	
		flock -u 63
	} 63<>${MANAGE_DEVS_LOCK}
}

fw_install_passthrough_icmp()
{
	local action="$1"
	local ifname="$2"
        local srcitf="$3"

	network_get_ipaddr srcip ${srcitf}
	case "${action}" in
		"add" )
			fw_add_passthrough_manage_devs -o ${ifname} -s ${srcip} -p icmp
		;;
		"del" )
			fw_del_passthrough_manage_devs_by_label ${ifname} "icmp"
		;;
	esac
}

fw_install_passthrough_dns()
{
	local action="$1"
	local ifname="$2"
	local srcitf="$3"

	network_get_ipaddr srcip ${srcitf}
	case "${action}" in
		"add" )
			fw_add_passthrough_manage_devs -o ${ifname} -s ${srcip} -p udp --dport 53
		;;
		"del" )
			fw_del_passthrough_manage_devs_by_label ${ifname} "dpt:53"
		;;
	esac

	# online check
	fw_install_passthrough_icmp "$@"
}

fw_event_manage_dev()
{
	local manage_devs_chain="manage_devs"
	local manage_devs="${1%%:*}"
	local updown="${1##*:}"

	{
		flock -x 63

		if ! iptables -w -C ${manage_devs_chain} -j DROP 2>/dev/null; then
			iptables -w -N ${manage_devs_chain}
			iptables -w -A output -j ${manage_devs_chain}
			iptables -w -A ${manage_devs_chain} -p tcp --dport 1723 -j RETURN
			iptables -w -A ${manage_devs_chain} -p udp -m multiport --dports 1701,67,20001 -j RETURN
			iptables -w -A ${manage_devs_chain} -j DROP
		fi

		case "${updown}" in
			"up")
				# setup new rule
				if ! iptables -w -C ${manage_devs_chain} -o ${manage_devs} -j RETURN 2>/dev/null; then
					iptables -w -I ${manage_devs_chain} 1 -o ${manage_devs} -j RETURN
				fi
				;;
			"down")
				# clean up old rule
				iptables -w -D ${manage_devs_chain} -o ${manage_devs} -j RETURN 2>/dev/null
				;;
			*)
				;;
		esac
		flock -u 63
	} 63<>${MANAGE_DEVS_LOCK}

	true ;
}

fw_load_manage_devs()
{
	network_flush_cache
	for zone in $(zone_get_zonelist) ; do
		local if_eth=$(uci -q get zone.${zone}.if_eth)
                local if_1=$(uci -q get zone.${zone}.if_1)
                local if_vpn=$(uci -q get zone.${zone}.iface)
                local ifaces="${if_eth} ${if_1} ${if_vpn}"
		for iface in ${ifaces} ; do
			if network_is_up ${iface}; then
				local device=$(zone_get_device_byif $iface)
				fw_event_manage_dev "${device}:up"
			fi
		done
	done

	if network_is_up "loopback"; then
		fw_event_manage_dev "lo:up"
	fi
}

# default netstack: IPV4/IPV6
fw_dual_ipt()
{
	iptables $@
	ip6tables $@
}

# vnet netstack: IPV4/IPV6
fw_dual_vnet_ipt()
{	
	vnete iptables $@
	vnete ip6tables $@
}

# default netstack & vnet netstack: IPV4/IPV6
fw_dual_anet_ipt()
{	
	anete iptables $@
	anete ip6tables $@
}

fw_load_service_default()
{
	local service_ports="53,67,137,138,161,500,1701,1900,4500,20002"
	[ "x"`is_all_in_one` = "x1" ] && service_ports="$service_ports,29810"  #一体机需要屏蔽29810收养端口

	fw_dual_ipt -w -N service_default
	fw_dual_ipt -w -A service_default -j reject
	#fw_dual_ipt -w -A input_default -p tcp -m multiport --dports $service_ports -j service_default
	[ "x"`is_all_in_one` = "x1" ] && fw_dual_ipt -w -A input_default -m extmark --extmark "${ALL_IN_ONE_MARK}/${ALL_IN_ONE_MARK}" -j ACCEPT #一体机开启NAT后允许通过的端口
	fw_dual_ipt -w -A input_default -p tcp -j service_default
	fw_dual_ipt -w -A input_default -p udp -j service_default
	. /lib/vnet/vnet_init.sh
	setup_lan_service_rules
	# fw_dual_ipt -w -A input_default -p udp -m multiport --dports 53,67,137,138,161,500,1701,1900,4500,20002 -j service_default

}

#0x10000
fw_load_forwarding_mark()
{
	forwarding_mark=$((1<<16))
	forwarding_excl_management_mark=$((1<<12))
	fw_dual_ipt -t mangle -w -I FORWARD 1 -j CONNMARK --or-mark ${forwarding_excl_management_mark}
	fw_dual_ipt -t mangle -w -I FORWARD 1 -j MARK --or-mark ${forwarding_excl_management_mark}
	fw_dual_ipt -t mangle -w -I FORWARD 1 -m set --match-set VMe src -j RETURN
	fw_dual_ipt -t mangle -w -I FORWARD 1 -m set --match-set VMe dst -j RETURN
	fw_dual_ipt -t mangle -w -I FORWARD 1 -j CONNMARK --or-mark ${forwarding_mark}
	fw_dual_ipt -t mangle -w -I FORWARD 1 -j MARK --or-mark ${forwarding_mark}

	#给OUTPUT的报文打上0x10000 mark，触发reroute check
	iptables -t mangle -w -I OUTPUT -p udp -m multiport ! --dports 1701,500,4500 -m multiport ! --sports 1701,500,4500 -j MARK --or-mark ${forwarding_mark}
	iptables -t mangle -w -I OUTPUT -p tcp -j MARK --or-mark ${forwarding_mark}
}

#-j MARK 0x800
fw_load_management_mark()
{
	management_mark=$((1<<11))
	fw_dual_ipt -t raw -w -A PREROUTING -m set --match-set Me dst -j MARK --or-mark ${management_mark}
	fw_dual_vnet_ipt -t raw -w -A PREROUTING -m set --match-set VMe dst -j MARK --or-mark ${management_mark}
	fw_dual_ipt -t raw -w -A OUTPUT -m set --match-set Me src -j MARK --or-mark ${management_mark}
	fw_dual_vnet_ipt -t raw -w -A OUTPUT -m set --match-set VMe src -j MARK --or-mark ${management_mark}
}
