# add a script to resolve bug 787033.
# 1. Sending of ICMP redirects remains active if at least one of the 
# net.ipv4.conf.$interface.send_redirects or net.ipv4.conf.all.send_redirects 
# is set to enable. 
# 2. Ensure that you set the net.ipv4.conf.$interface.send_redirects 
# option to 0 for every interface include all.
# 3. To automatically set the option whenever you add a new interface, 
# set the net.ipv4.conf.default.send_redirects option.

set_option()
{
    NET_PREFIX=$1
    OPTION=$2
    interfaces_group=`$NET_PREFIX ls /proc/sys/net/ipv4/conf`
    for interface in $interfaces_group; do
        echo $interface
        $NET_PREFIX sysctl -w net.ipv4.conf.$interface.send_redirects=$OPTION
    done
}
#1. 将双协议栈下的所有interface的send_redirects值置为0
set_option dnete 0
set_option vnete 0
#2. 保持standalone和controller的默认值一致为开启状态
dnete sysctl -w net.ipv4.conf.all.send_redirects=1
vnete sysctl -w net.ipv4.conf.all.send_redirects=1

