#ifndef __RTL8367SC_API_H__
#define __RTL8367SC_API_H__
#include "rtl8367sc_api/rtk_types.h"
#include "rtl8367sc_api/dal/rtl8367d/rtl8367d_reg.h"
#include "rtl8367sc_api/acl.h"
#include "rtl8367sc_api/chip.h"
#include "rtl8367sc_api/cpu.h"
#include "rtl8367sc_api/dot1x.h"
#include "rtl8367sc_api/eee.h"
#include "rtl8367sc_api/gpio.h"
#include "rtl8367sc_api/i2c.h"
#include "rtl8367sc_api/igmp.h"
#include "rtl8367sc_api/interrupt.h"
#include "rtl8367sc_api/l2.h"
#include "rtl8367sc_api/leaky.h"
#include "rtl8367sc_api/led.h"
#include "rtl8367sc_api/mirror.h"
#include "rtl8367sc_api/oam.h"
#include "rtl8367sc_api/port.h"
#include "rtl8367sc_api/ptp.h"
#include "rtl8367sc_api/qos.h"
#include "rtl8367sc_api/rate.h"
#include "rtl8367sc_api/rldp.h"
#include "rtl8367sc_api/rtk_error.h"
#include "rtl8367sc_api/rtk_switch.h"

#include "rtl8367sc_api/stat.h"
#include "rtl8367sc_api/storm.h"
#include "rtl8367sc_api/svlan.h"
#include "rtl8367sc_api/trap.h"
#include "rtl8367sc_api/trunk.h"
#include "rtl8367sc_api/vlan.h"
#include "rtl8367sc_api/dal/dal_mapper.h"
#include "rtl8367sc_api/dal/dal_mgmt.h"

#include <dal_rtl8367d_rate.h>
#include <dal_rtl8367d_rldp.h>
#include <dal_rtl8367d_stat.h>
#include <dal_rtl8367d_storm.h>
#include <dal_rtl8367d_svlan.h>
#include <dal_rtl8367d_switch.h>
#include <dal_rtl8367d_igmp.h>
#include <dal_rtl8367d_trap.h>
#include <dal_rtl8367d_trunk.h>
#include <dal_rtl8367d_vlan.h>
#include <rtl8367d_asicdrv.h>
#include <rtl8367d_reg.h>
#include <rtl8367d_smi.h>
#include <dal_rtl8367d_acl.h>
#include <dal_rtl8367d_cpu.h>
#include <dal_rtl8367d_dot1x.h>
#include <dal_rtl8367d_eee.h>
#include <dal_rtl8367d_gpio.h>
#include <dal_rtl8367d_igmp.h>
#include <dal_rtl8367d_interrupt.h>
#include <dal_rtl8367d_l2.h>
#include <dal_rtl8367d_leaky.h>
#include <dal_rtl8367d_led.h>
#include <dal_rtl8367d_mapper.h>
#include <dal_rtl8367d_mirror.h>
#include <dal_rtl8367d_port.h>
#include <dal_rtl8367d_qos.h>



rtk_api_ret_t rtk_switch_init(void);

rtk_api_ret_t rtk_vlan_init(void);
rtk_api_ret_t rtk_vlan_set(rtk_vlan_t vid, rtk_vlan_cfg_t *pVlanCfg);
rtk_api_ret_t rtk_vlan_get(rtk_vlan_t vid, rtk_vlan_cfg_t *pVlanCfg);
rtk_api_ret_t rtk_vlan_portPvid_set(rtk_port_t port, rtk_vlan_t pvid, rtk_pri_t priority);

rtk_port_t rtk_switch_port_P2L_get(rtk_uint32 physicalPort);
rtk_uint32 rtk_switch_port_L2P_get(rtk_port_t logicalPort);
ret_t rtk_switch_getReg(rtk_uint32 reg, rtk_uint32 *pValue);
ret_t rtk_switch_setReg(rtk_uint32 reg, rtk_uint32 value);
ret_t rtk_switch_setPHYReg(rtk_uint32 phyNo, rtk_uint32 phyAddr, rtk_uint32 phyData);
ret_t rtk_switch_getPHYReg(rtk_uint32 phyNo, rtk_uint32 phyAddr, rtk_uint32 *pRegData);

rtk_api_ret_t rtk_port_macStatus_get(rtk_port_t port, rtk_port_mac_ability_t *pPortstatus);
rtk_api_ret_t rtk_port_macForceLinkExt_set(rtk_port_t port, rtk_mode_ext_t mode, rtk_port_mac_ability_t *pPortability);

rtk_api_ret_t rtk_stat_port_get(rtk_port_t port, rtk_stat_port_type_t cntr_idx, rtk_stat_counter_t *pCntr);
rtk_api_ret_t rtk_stat_port_getAll(rtk_port_t port, rtk_stat_port_cntr_t *pPort_cntrs);
rtk_api_ret_t rtk_stat_port_reset(rtk_port_t port);
void bind_static_lan_mac(rtk_uint8 *mac);
rtk_api_ret_t rtk_mirror_portIso_set(rtk_enable_t enable);
rtk_api_ret_t rtk_mirror_portBased_set(rtk_port_t mirroring_port, rtk_portmask_t *pMirrored_rx_portmask, rtk_portmask_t *pMirrored_tx_portmask);
rtk_api_ret_t rtk_mirror_portBased_get(rtk_port_t *pMirroring_port, rtk_portmask_t *pMirrored_rx_portmask, rtk_portmask_t *pMirrored_tx_portmask);
rtk_api_ret_t rtk_led_enable_set(rtk_led_group_t group, rtk_portmask_t *pPortmask);
rtk_api_ret_t rtk_led_operation_set(rtk_led_operation_t mode);
rtk_api_ret_t rtk_led_blinkRate_set(rtk_led_blink_rate_t blinkRate);
rtk_api_ret_t rtk_led_groupConfig_set(rtk_led_group_t group, rtk_led_congig_t config);
rtk_api_ret_t rtk_led_modeForce_set(rtk_port_t port, rtk_led_group_t group, rtk_led_force_mode_t mode);
rtk_api_ret_t rtk_port_rgmiiDelayExt_set(rtk_port_t port, rtk_data_t txDelay, rtk_data_t rxDelay);
rtk_api_ret_t rtk_port_rgmiiDelayExt_get(rtk_port_t port, rtk_data_t *pTxDelay, rtk_data_t *pRxDelay);
init_state_t rtk_switch_initialState_get(void);
rtk_api_ret_t rtk_switch_isExtPort(rtk_port_t logicalPort);

rtk_int32 smi_read(rtk_uint32 mAddrs, rtk_uint32 *rData);
rtk_int32 smi_write(rtk_uint32 mAddrs, rtk_uint32 rData);
rtk_api_ret_t rtk_switch_logicalPortCheck(rtk_port_t logicalPort);
rtk_api_ret_t rtk_switch_logPortMask_get(rtk_portmask_t *pPortmask);



extern rtk_api_ret_t rtk_filter_igrAcl_init(void);
extern rtk_api_ret_t rtk_filter_igrAcl_field_add(rtk_filter_cfg_t *pFilter_cfg, rtk_filter_field_t *pFilter_field);
extern rtk_api_ret_t rtk_filter_igrAcl_cfg_add(rtk_filter_id_t filter_id, rtk_filter_cfg_t *pFilter_cfg, rtk_filter_action_t *pAction, rtk_filter_number_t *ruleNum);
extern rtk_api_ret_t rtk_filter_igrAcl_cfg_del(rtk_filter_id_t filter_id);
extern rtk_api_ret_t rtk_filter_igrAcl_cfg_delAll(void);
extern rtk_api_ret_t rtk_filter_igrAcl_cfg_get(rtk_filter_id_t filter_id, rtk_filter_cfg_raw_t *pFilter_cfg, rtk_filter_action_t *pAction);
extern rtk_api_ret_t rtk_filter_igrAcl_unmatchAction_set(rtk_port_t port, rtk_filter_unmatch_action_t action);
extern rtk_api_ret_t rtk_filter_igrAcl_unmatchAction_get(rtk_port_t port, rtk_filter_unmatch_action_t* action);
extern rtk_api_ret_t rtk_filter_igrAcl_state_set(rtk_port_t port, rtk_filter_state_t state);
extern rtk_api_ret_t rtk_filter_igrAcl_state_get(rtk_port_t port, rtk_filter_state_t* state);
extern rtk_api_ret_t rtk_filter_igrAcl_template_set(rtk_filter_template_t *aclTemplate);
extern rtk_api_ret_t rtk_filter_igrAcl_template_get(rtk_filter_template_t *aclTemplate);
extern rtk_api_ret_t rtk_filter_igrAcl_field_sel_set(rtk_uint32 index, rtk_field_sel_t format, rtk_uint32 offset);
extern rtk_api_ret_t rtk_filter_igrAcl_field_sel_get(rtk_uint32 index, rtk_field_sel_t *pFormat, rtk_uint32 *pOffset);
extern rtk_api_ret_t rtk_filter_iprange_set(rtk_uint32 index, rtk_filter_iprange_t type, ipaddr_t upperIp, ipaddr_t lowerIp);
extern rtk_api_ret_t rtk_filter_iprange_get(rtk_uint32 index, rtk_filter_iprange_t *pType, ipaddr_t *pUpperIp, ipaddr_t *pLowerIp);
extern rtk_api_ret_t rtk_filter_vidrange_set(rtk_uint32 index, rtk_filter_vidrange_t type, rtk_uint32 upperVid, rtk_uint32 lowerVid);
extern rtk_api_ret_t rtk_filter_vidrange_get(rtk_uint32 index, rtk_filter_vidrange_t *pType, rtk_uint32 *pUpperVid, rtk_uint32 *pLowerVid);
extern rtk_api_ret_t rtk_filter_portrange_set(rtk_uint32 index, rtk_filter_portrange_t type, rtk_uint32 upperPort, rtk_uint32 lowerPort);
extern rtk_api_ret_t rtk_filter_portrange_get(rtk_uint32 index, rtk_filter_portrange_t *pType, rtk_uint32 *pUpperPort, rtk_uint32 *pLowerPort);
extern rtk_api_ret_t rtk_filter_igrAclPolarity_set(rtk_uint32 polarity);
extern rtk_api_ret_t rtk_filter_igrAclPolarity_get(rtk_uint32* pPolarity);
extern rtk_api_ret_t rtk_svlan_init(void);
extern rtk_api_ret_t rtk_svlan_servicePort_add(rtk_port_t port);
extern rtk_api_ret_t rtk_svlan_servicePort_get(rtk_portmask_t *pSvlan_portmask);
extern rtk_api_ret_t rtk_svlan_servicePort_del(rtk_port_t port);
extern rtk_api_ret_t rtk_svlan_tpidEntry_set(rtk_uint32 svlan_tag_id);
extern rtk_api_ret_t rtk_svlan_tpidEntry_get(rtk_uint32 *pSvlan_tag_id);
extern rtk_api_ret_t rtk_svlan_priorityRef_set(rtk_svlan_pri_ref_t ref);
extern rtk_api_ret_t rtk_svlan_priorityRef_get(rtk_svlan_pri_ref_t *pRef);
extern rtk_api_ret_t rtk_svlan_memberPortEntry_set(rtk_uint32 svid_idx, rtk_svlan_memberCfg_t *psvlan_cfg);
extern rtk_api_ret_t rtk_svlan_memberPortEntry_get(rtk_uint32 svid_idx, rtk_svlan_memberCfg_t *pSvlan_cfg);
extern rtk_api_ret_t rtk_svlan_memberPortEntry_adv_set(rtk_uint32 idx, rtk_svlan_memberCfg_t *pSvlan_cfg);
extern rtk_api_ret_t rtk_svlan_memberPortEntry_adv_get(rtk_uint32 idx, rtk_svlan_memberCfg_t *pSvlan_cfg);
extern rtk_api_ret_t rtk_svlan_defaultSvlan_set(rtk_port_t port, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_defaultSvlan_get(rtk_port_t port, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_c2s_add(rtk_vlan_t vid, rtk_port_t src_port, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_c2s_del(rtk_vlan_t vid, rtk_port_t src_port);
extern rtk_api_ret_t rtk_svlan_c2s_get(rtk_vlan_t vid, rtk_port_t src_port, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_untag_action_set(rtk_svlan_untag_action_t action, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_untag_action_get(rtk_svlan_untag_action_t *pAction, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_unmatch_action_set(rtk_svlan_unmatch_action_t action, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_unmatch_action_get(rtk_svlan_unmatch_action_t *pAction, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_dmac_vidsel_set(rtk_port_t port, rtk_enable_t enable);
extern rtk_api_ret_t rtk_svlan_dmac_vidsel_get(rtk_port_t port, rtk_enable_t *pEnable);
extern rtk_api_ret_t rtk_svlan_ipmc2s_add(ipaddr_t ipmc, ipaddr_t ipmcMsk, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_ipmc2s_del(ipaddr_t ipmc, ipaddr_t ipmcMsk);
extern rtk_api_ret_t rtk_svlan_ipmc2s_get(ipaddr_t ipmc, ipaddr_t ipmcMsk, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_l2mc2s_add(rtk_mac_t mac, rtk_mac_t macMsk, rtk_vlan_t svid);
extern rtk_api_ret_t rtk_svlan_l2mc2s_del(rtk_mac_t mac, rtk_mac_t macMsk);
extern rtk_api_ret_t rtk_svlan_l2mc2s_get(rtk_mac_t mac, rtk_mac_t macMsk, rtk_vlan_t *pSvid);
extern rtk_api_ret_t rtk_svlan_sp2c_add(rtk_vlan_t svid, rtk_port_t dst_port, rtk_vlan_t cvid);
extern rtk_api_ret_t rtk_svlan_sp2c_get(rtk_vlan_t svid, rtk_port_t dst_port, rtk_vlan_t *pCvid);
extern rtk_api_ret_t rtk_svlan_sp2c_del(rtk_vlan_t svid, rtk_port_t dst_port);
extern rtk_api_ret_t rtk_svlan_lookupType_set(rtk_svlan_lookupType_t type);
extern rtk_api_ret_t rtk_svlan_lookupType_get(rtk_svlan_lookupType_t *pType);
extern rtk_api_ret_t rtk_svlan_trapPri_set(rtk_pri_t priority);
extern rtk_api_ret_t rtk_svlan_trapPri_get(rtk_pri_t *pPriority);
extern rtk_api_ret_t rtk_svlan_unassign_action_set(rtk_svlan_unassign_action_t action);
extern rtk_api_ret_t rtk_svlan_unassign_action_get(rtk_svlan_unassign_action_t *pAction);
/*
 * Data Type Declaration
 */
#define RTK_MAX_METER_ID            (rtk_switch_maxMeterId_get())
#define RTK_METER_NUM               (RTK_MAX_METER_ID + 1)
#define RTL8367C_MAX_LOG_CNT_NUM                (32)
#define RTL8367C_DSCPMAX    				63

#define RTK_CHK_PORT_VALID(__port__)                            \
    do                                                          \
    {                                                           \
        if(rtk_switch_logicalPortCheck(__port__) != RT_ERR_OK)  \
        {                                                       \
            return RT_ERR_PORT_ID;                              \
        }                                                       \
    }while(0)
#define RTK_CHK_PORTMASK_VALID(__portmask__)                        \
    do                                                              \
    {                                                               \
        if(rtk_switch_isPortMaskValid(__portmask__) != RT_ERR_OK)   \
        {                                                           \
            return RT_ERR_PORT_MASK;                                  \
        }                                                           \
    }while(0)
#define RTK_MAX_NUM_OF_PROTO_TYPE                   0xFFFF
#define RTL8367C_EFIDMAX                    0x7
#define RTL8367C_FIDMAX                     0xF

enum {
	CMT_ACTION_FLUSH,
	CMT_ACTION_ADD_DENY,
	CMT_ACTION_ADD_ALLOW,
	CMT_ACTION_MAX
};

extern int rtk_acl_init(void);
extern int rtk_acl_cfg_start(void **handl);
extern int rtk_acl_cfg_add_snet(void *handl, unsigned int ipaddr, unsigned int ipmask);
extern int rtk_acl_cfg_add_dnet(void *handl, unsigned int ipaddr, unsigned int ipmask);
extern int rtk_acl_cfg_add_vid(void *handl, unsigned short vid);
extern int rtk_acl_cfg_add_padding(void *handl);
extern int rtk_acl_cfg_commit(void *handl, int action, int index, int port, int *outdex);
extern int rtk_acl_cfg_finish(void *handl);
#endif /* __RTL8367S_API_H__ */
