#!/bin/bash

COMMOM_UP_PATH=$1
MERGE_GROUP=$2
FILE_TABLE="child_file_table.bin"

function merge_child_file(){
    for element in `ls $1`
    do
        dir_or_file=$1"/"$element
        if [ -d $dir_or_file ]
        then
            merge_child_file $dir_or_file $2
        else
            name=`du -b $dir_or_file | awk '{print $2}'`
            #size=`du -b $dir_or_file | awk '{print $1}'`
            cat ${name} >> $2
        fi
    done
}

#按照文件列表拼接镜像
function merge_image(){
	dsl_dir=$1
	lte_dir=$2
	no_md5_up_name=$3

	echo "truncate -s 1024 ${no_md5_up_name}"
	truncate -s 1024 ${no_md5_up_name}
    echo -e >> ${no_md5_up_name}
    cat ${FILE_TABLE} >> ${no_md5_up_name}
    truncate -s 3072 ${no_md5_up_name}
    cat ${COMMOM_UP_PATH} >> ${no_md5_up_name}
	[ "${dsl_dir}" != "no_dsl" ] && merge_child_file ${dsl_dir} ${no_md5_up_name}
	[ "${lte_dir}" != "no_lte" ] && merge_child_file ${lte_dir} ${no_md5_up_name}
}

function get_child_file(){
    for element in `ls $1`
    do
        dir_or_file=$1"/"$element
        if [ -d $dir_or_file ]
        then
            get_child_file $dir_or_file $2
        else
            name=`du -b $dir_or_file | awk '{print $2}'`
            size=`du -b $dir_or_file | awk '{print $1}'`
            echo "/tmp/${name},${size}" >> $2
        fi
    done
}

#制作镜像的文件列表，包含文件路径和大小
function make_file_table(){
	rm -rf ${FILE_TABLE}
	dsl_dir=$1
	lte_dir=$2

	common_up_size=`du -b ${COMMOM_UP_PATH} | awk '{print $1}'`
	echo "/tmp/up.bin,${common_up_size}" >> ${FILE_TABLE}
	[ "${dsl_dir}" != "no_dsl" ] && get_child_file ${dsl_dir} ${FILE_TABLE}
	[ "${lte_dir}" != "no_lte" ] && get_child_file ${lte_dir} ${FILE_TABLE}
}

if [ -n ${MERGE_GROUP} ]; then
	#生成文件列表和合成固件
	DSL_IMAGE_DIR="no_dsl"
	dsl_flag=`echo ${MERGE_GROUP} | grep "dsl"`
	[ -n "${dsl_flag}" ] && DSL_IMAGE_DIR="dsl_upgrade"

	LTE_IMAGE_DIR="no_lte"
	lte_flag=`echo ${MERGE_GROUP} | grep "lte"`
	if [ -n "${lte_flag}" ]; then
		region=`echo ${MERGE_GROUP} | awk -F "lte_" '{print $2}'`
		LTE_IMAGE_DIR="qfirehose_${region}"
		[ ! -d ${LTE_IMAGE_DIR} ] && unzip -o ${LTE_IMAGE_DIR}".zip" -d ${LTE_IMAGE_DIR}
	fi

	make_file_table ${DSL_IMAGE_DIR} ${LTE_IMAGE_DIR}
	IMAGE_NAME="no_md5_${MERGE_GROUP}_up.bin"
	merge_image ${DSL_IMAGE_DIR} ${LTE_IMAGE_DIR} ${IMAGE_NAME}
fi
