#!/bin/sh

. /lib/zone/zone_api.sh
. /lib/functions.sh

CMXDDNS_READY=/tmp/cmxddnsFlag
#echo -e "`date +%Y%m%d-%H:%M:%S` $INTERFACE $ACTION" > /dev/console
CMXDDNS_MODULE="ddns"
CMXDDNS_EID="02005003"
CMXDDNS_DESC_CONN_SVR_FAIL="02105081"
[ ! -f $CMXDDNS_READY ] && {
#	echo -e "CMXDDNS not ready,ingore this evnet" > /dev/console
	exit 0
}

if_iface_enable() {
    local cfg="$1"
    local interface=`uci -q get cmxddns.$cfg.interface`
    local iface=`echo ${2} | tr '[a-z]' '[A-Z]'`
    if [ "$interface" = "$iface" ]; then
        local if_on=`uci -q get cmxddns.$cfg.enable`
        if [ "$if_on" = "on" ]; then
            ubus call ievent add "{\"module\":\"$CMXDDNS_MODULE\",\"eid\":\"$CMXDDNS_EID\",\"errcode\":\"$CMXDDNS_DESC_CONN_SVR_FAIL\"}"
        fi
    fi
}

case "$ACTION" in
    ifup)
        /etc/init.d/cmxddns restart
    ;;
	ifdown)
        /etc/init.d/cmxddns restart
        local iface=${INTERFACE:0:3}
        if [ "$iface" = "wan" ]; then
            iface=${INTERFACE%_*}
            config_load cmxddns
            config_foreach if_iface_enable cmxddns $iface
        fi
    ;;
esac
