#!/bin/sh
#echo ${INTERFACE}+$ACTION+$DEVICE >> "/tmp/online/tmp_record"
[ ${INTERFACE:$((${#INTERFACE}-2))} == "v6" ] && exit 0
. /lib/functions.sh
. /lib/zone/zone_api.sh

[ "${INTERFACE:0:3}" = "wan" ] && [ "$ACTION" = "ifup" -o "$ACTION" = "ifdown" ] && {
	rdev=$(zone_get_effect_devices ${INTERFACE})
	echo $ACTION > "/tmp/online/state_$rdev"
	if ubus call online get_ifaces_state | grep -rq "\"$DEVICE\""; then
		if [ "$ACTION" = "ifup" ]; then
			ubus call online refresh_action "{\"dev\":\"$rdev\", \"action\":\"$ACTION\"}"
		fi
	else
		. /lib/online_check/online_api.sh
		zone=$(zone_get_zone_byif ${INTERFACE})
		if [ -n "$zone" ]; then
			del_online_check "${zone}"
			mode=$(uci get online.${zone}.mode)
			gateway=$(uci get online.${zone}.gateway)
			dns=$(uci get online.${zone}.dns)
			add_online_check "${zone}"
			update_online_manual_check "${zone}" "${mode}" "${gateway}" "${dns}"
		fi
	fi
}
