#!/bin/sh
VNET_LIBDIR=/lib/vnet

[ -z "$INTERFACE" -o "$INTERFACE" = "vwan" ] && exit 0
vnet_add_zone()
{
	local interface="$1"
	local zone_old
	[ -n "$interface" ] && {
		. /lib/config/uci.sh
		. /lib/zone/zone_conf.sh
		config_load vnetwork
		local ifname zone
		config_get ifname "$interface" ifname
		config_get zone "$interface" zone
		#add zone config
		uci_add zone zone "$zone"
		uci_set zone "$zone" if_eth "$interface"
		uci_set zone "$zone" dev_eth "$ifname"
		uci_set zone "$zone" creator "vnet"
		uci commit zone
		# add zone state
		local flag="true"
		for zs in $(uci_get_state zone core zones); do
			local i=${zs#*}
			append zone_old $i
			[ "$i" == "$zone" ] && {
				flag="false"
				break
			} 
		done
		[ "$flag" == "true" ] && {
			append zone_old $zone  
			uci_toggle_state zone core zones "$zone_old"
			_zone_state_config $zone
		}
	}
}

case "$ACTION" in
	add)
		. /lib/functions.sh
		. ${VNET_LIBDIR}/vnet_init.sh
		# The addition of downstream routes during the boot phase 
		# should be delayed until the interface (inf) has started up normally.
		[ -z "$VNET_BOOTING" ] && {
			build_downstream_routes "$INTERFACE"
		}
		vnet_add_zone "$INTERFACE"
		;;
esac
