#!/bin/sh

. /lib/functions.sh
local DNSPROXY_SHELL="/lib/dnsproxy/main.sh"
local CONF_VAR="/var/unbound/unbound.conf"
[ -z "$INTERFACE" ] && exit 0

unbound_add_interface()
{
	#add interface
	local ip=$1
	echo "add unbound interface $ip" >/dev/console
	local exist=`cat $CONF_VAR | grep "interface: ${ip}@53"`
	if [ -z "$exist" ]; then
		sed -i "/.*verbosity*/a\        interface: ${ip}@53" $CONF_VAR
	fi
}
unbound_delete_interface()
{
	#delete interface
	local ip=$1
	echo "delete unbound interface $ip" >/dev/console
	sed -i "/interface: ${ip}@53/d" $CONF_VAR
}


case "$ACTION" in
	add)
		
		[ "$INTERFACE" = "vwan" ] && {
			return 0
		}
		config_load vnetwork
                config_get ipaddr "$INTERFACE" ipaddr

		unbound_add_interface $ipaddr
		${DNSPROXY_SHELL} reload
		;;
	delete)
		
		[ "$INTERFACE" = "vwan" ] && {
			return 0
		}
		config_load vnetwork
                config_get ipaddr "$INTERFACE" ipaddr

		unbound_delete_interface $ipaddr
		${DNSPROXY_SHELL} reload
		;;
esac
