#!/bin/sh
[ -z "$INTERFACE" ] && exit 0

# [ -n "$VNET_BOOTING" ] && [ -z "$FIREWALL_BOOTING" ] && exit 0

DHCPS_LIBDIR=/lib/dhcps
DHCPS_CONFIGFILE="/etc/config/dhcp"

echo "INTERAFCE:${INTERFACE}start adding dhcp configure----------------------------action${ACTION}" > /dev/console
. /lib/functions.sh
. ${DHCPS_LIBDIR}/dhcps.sh

case "$ACTION" in
	add)
		config_load vnetwork
		build_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		build_dhcps_dnsmasq $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	delete)
		clean_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	notify)
		config_load vnetwork
		build_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		build_dhcps_dnsmasq $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	commit)
		[ -z "$VNET_BOOTING" ] && {
			/etc/init.d/dnsmasq restart
		}
		;;
esac
