#!/bin/sh

. /lib/zone/zone_api.sh
. /lib/functions.sh

PHDDNS_READY=/tmp/phddnsFlag
#echo "`date +%Y%m%d-%H:%M:%S` $INTERFACE $ACTION" > /dev/console
PHDDNS_MODULE="ddns"
PHDDNS_EID="02005003"
PHDDNS_CONN_CENSRV_FAIL="02105141"
[ ! -f $PHDDNS_READY ] && {
	#echo "PHDDNS not ready,ingore this evnet" > /dev/console
	exit 0
}

if_iface_enable() {
    local cfg="$1"
    local interface=`uci -q get phddns.$cfg.interface`
    local iface=`echo ${2} | tr '[a-z]' '[A-Z]'`
    if [ "$interface" = "$iface" ]; then
        local if_on=`uci -q get phddns.$cfg.enable`
        if [ "$if_on" = "on" ]; then
            ubus call ievent add "{\"module\":\"$PHDDNS_MODULE\",\"eid\":\"$PHDDNS_EID\",\"errcode\":\"$PHDDNS_CONN_CENSRV_FAIL\"}"
        fi
    fi
}

case "$ACTION" in
    ifup)
        /etc/init.d/phddns restart
    ;;
	ifdown)
        /etc/init.d/phddns restart
        local iface=${INTERFACE:0:3}
        if [ "$iface" = "wan" ]; then
            iface=${INTERFACE%_*}
            config_load "phddns"
            config_foreach if_iface_enable phddns $iface
        fi
    ;;
esac

