#!/bin/sh

. /lib/remote_mngt/remote_mngt.sh

_delete_rule() {
    local cfg="$1"
    local del_if="$2"
    local iface

    iface=$(uci_get remote_mngt "$cfg" iface)
    [ "$del_if" == "$iface" ] && {
        uci delete remote_mngt.$cfg
    }
}

case ${ACTION} in
    DELETE)
        [ -n "${interfaces}" ] && {
            [ "${virtual_wan_hook}" == "yes" ] && {
                [ -n "${ifaces}" ] && {
                    ifaces=${ifaces//,/ }
                    for iface in $ifaces
                    do
                        config_load remote_mngt
                        config_foreach _delete_rule mngt_iface $iface
                        uci_commit remote_mngt
                    done
                }
                /lib/cfg_save/config.sh save
            }

            echo "interfaces=$interfaces" >> /tmp/remote_mngt_wanhook.log
			/etc/init.d/remote_mngt reload
        }
    ;;
    ADD)
        [ -n "${interfaces}" ] && {
            [ "${virtual_wan_hook}" == "yes" ] && {
                [ -n "${ifaces}" ] && {
                    ifaces=${ifaces//,/ }
                    for iface in $ifaces
                    do
                        cfg=`uci add remote_mngt mngt_iface`
                        uci set remote_mngt.$cfg.iface=$iface
                        uci set remote_mngt.$cfg.enabled=off
                        uci commit
                    done
                }
                /lib/cfg_save/config.sh save
            }

            echo "interfaces=$interfaces" >> /tmp/remote_mngt_wanhook.log
			/etc/init.d/remote_mngt reload
		}
    ;;
	WANMOD)
        [ -n "${interfaces}" ] && {
            echo "interfaces=$interfaces" >> /tmp/remote_mngt_wanhook.log
			#/etc/init.d/remote_mngt reload
            rmc_mod_wan_mngt_byzone "${interfaces}"
		}
    ;;
    *)
    ;;
esac

