#!/bin/sh
. /lib/functions.sh
. /lib/zone/zone_api.sh
. /lib/freeStrategy/core_rule.sh

WPORTAL_LIBDIR=/lib/wportal
. $WPORTAL_LIBDIR/core_wportal.sh

local ssid_config_file="ssid_list"
local wportal_config_file="wportal"
local under_controller="0"
local isCsMng=`cat /etc/config/controller.conf | grep csId | grep c21f969b5f03d33d43e04f8f136e7682 | wc -l`

if [ ${isCsMng} -le 0 ] ; then
	under_controller="1"
	echo "[wlan hotplug] gw is under_controller = $under_controller"
fi
[ "$under_controller" = "1" ] && exit 0

config_load ${ssid_config_file}
config_get ssid "$INTERFACE" "ssid"
config_get id "$INTERFACE" "id"
config_get ifname "$INTERFACE" "ifname"

_delete_portaldb_by_ssid(){
sqlite3 /etc/config/portal.db <<EOF
delete from wportal where interface='$1';
EOF
}

_update_rule(){
	local section_name="$1"
	local tmp_ssid_ifname="$2"
	config_get ifname_list $section_name interface
	for i in $ifname_list ;do
		if [ "$i" = "$tmp_ssid_ifname" ];then
			echo "find $i in wportal" > /dev/console
			#/etc/init.d/wifidog restart
            /usr/bin/wifidog-init restart
			rule_restart
			break
		fi
	done
}

_delete_rule(){
	local section_name="$1"
	local tmp_ssid_ifname="$2"
	config_get ifname_list $section_name interface
	for i in $ifname_list ;do
		if [ "$i" = "$tmp_ssid_ifname" ];then
			echo "find $i in wportal" >> /dev/console
			#/etc/init.d/wifidog restart
			uci del_list wportal.dft_wportal.interface="$i"
			uci del_list wportal.dft_wportal.gw_id="$i"
			uci del_list wportal.dft_wportal.ssid_interface_for_freeStrategy_init="$i"
			uci commit
			_delete_portaldb_by_ssid $i
			config_load ${wportal_config_file}
			set_wifidog_conf
			/usr/bin/wifidog-init restart
		    rule_restart
			/lib/cfg_save/config.sh save	
			break
		fi
	done                            
}

update_wportal_by_ssid_ifname(){
    config_load ${wportal_config_file}
	config_foreach _update_rule wportal "$1"
}

delete_wportal_by_ssid_ifname(){
    config_load ${wportal_config_file}
	config_foreach _delete_rule wportal "$1"
}

case "$ACTION" in
	UPDATE)
        # config_load "wportal"
        # config_get global_enable dft_wportal enable
        # if [ "$global_enable" == "on" ]
        # then
		# 	update_wportal_by_ssid_ifname $ifname
		# fi
	;;
	DELETE)
		delete_wportal_by_ssid_ifname $INTERFACE
	;;
	CFG_SAVE)
		config_load "wportal"
		config_get global_enable dft_wportal enable
		if [ "$global_enable" == "on" ]
		then
			# 检查wportal是否绑定ssid
			config_get wportal_infs dft_wportal interface
			for i in $wportal_infs; do
				if uci get ssid_list.$i >/dev/null 2>&1; then
					/usr/bin/wifidog-init restart
					rule_restart
					break
				fi
			done
		fi
	;;
	*)
		# do nothing
	;;
esac
