#!/bin/sh
. /lib/firewall/fw.sh
. /lib/zone/zone_api.sh
. /lib/access_ctl/markdef.sh
. /usr/share/libubox/jshn.sh

acl_device_info_file="/tmp/device-info.json"
local config_file="access_ctl"
# options of access_ctl
local zone=""
local service=""
local src=""
local dest=""
#local srcIf=""
#local destIf=""
local srcIfName=""
local destIfName=""
local name=""
local policy=""
local policy_rev=""
local position=0
local states=""
local wireless_flag=0
local dst_domain_flag=0
local extmark=0
local action=""
local log=0
local log_param=""
local acl_chains="access_ctl_me access_ctl"
ACL_LOG()
{
  t="`date +"%Y-%M-%d %H:%m:%S"`"
  #echo "$t ---> $1" >> /tmp/acl_rule.log
}

fw_acl_ipset_check()
{
  #echo "argv1=$1"
  local ret=$(ipset -L|grep $1 | awk '{print $2}')

  #[ "$ret" == "$1" ] && return 0||return 1
  return 0

}

fw_check() {
  local vnet_prefix=$4
  local ret=$(${vnet_prefix} iptables -w -t $1 -C $2 $3 2>&1)
  [ -n "$ret" ] && return 0||return 1
}

# _set_acl_srcIfName(){
# 	local section_name="$1"
# 	local tmp_ssid_id="$2"
# 	config_get id $section_name id
# 	config_get ifname $section_name ifname
# 	if [ "$id" -eq "$tmp_ssid_id" ];then
# 		if [ -z "$srcIfName" ];then
# 			srcIfName="$ifname"
# 		else
# 			srcIfName="$srcIfName"",""$ifname"
# 		fi
# 	fi
# }

# _set_acl_destIfName(){
# 	local section_name="$1"
# 	local tmp_ssid_id="$2"
# 	config_get id $section_name id
# 	config_get ifname $section_name ifname
# 	if [ "$id" -eq "$tmp_ssid_id" ];then
# 		if [ -z "$destIfName" ];then
# 			destIfName="$ifname"
# 		else
# 			destIfName="$destIfName"",""$ifname"
# 		fi
# 	fi
# }

acl_wan_zone_convert()
{
	local num=`echo $1| sed 's/[^0-9]//g'`
	echo "ZV_W$num"
}

acl_zone_in_flag()
{
	local wan=`echo "$1" | grep "^WAN[0-9]\+$"`
	[ -n "$wan" ] && {
		echo "WAN"
		return
	}
	local vpns=`zone_get_ifaces "VPN"`
	for vpn in $vpns
	do
		if [ "$1" == "$vpn" ];then
			echo "VPN"
			return
		fi
	done
	echo "0"
}

# reversed-order,have to find the rule before the given rulename,then insert it 
get_other_info(){
  local target_name=$1
  #local loop=0
  #local result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  #while [ x$result != 'x' ];do
  #  local name=$result
  #  [ $name == $target_name ] && {
  #     zone=$(uci get access_ctl.@rule_acl_inner[$loop].zone 2>/dev/null)
  #     service=$(uci get access_ctl.@rule_acl_inner[$loop].service 2>/dev/null)
  #     src=$(uci get access_ctl.@rule_acl_inner[$loop].src 2>/dev/null)
  #     dest=$(uci get access_ctl.@rule_acl_inner[$loop].dest 2>/dev/null)
  #     policy=$(uci get access_ctl.@rule_acl_inner[$loop].policy 2>/dev/null)
  #     break
  #  }
  #  loop=$(($loop+1))
  #  result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  #done
   # as config file stores the item in a reversed order,so,we need to keep on going
  # loop=$(($loop+1))
  # result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  # while [ x$result != 'x' ];do
  #     local ret=$(iptables -w -n -L access_ctl --line-number | grep "\b${result}_1acl\b" | cut -d ' ' -f 1)
  #     if [ x"$ret" != 'x' ];then
  #        ret=${ret//\n/ }     
  #        for i in $ret;do
  #          position=$i  # just get the first if have many
  #          break
  #        done  
  #        break
  #     fi
  #    loop=$(($loop+1))
  #    result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  # done

   #local tmpx=0
   #while [ $tmpx -lt $loop ];do
   #  result=$(uci get access_ctl.@rule_acl_inner[$tmpx].name 2>/dev/null)
   #  local ret=$(iptables -n -L access_ctl --line-number | grep $result | cut -d ' ' -f 1)
   #  if [ x"$ret" != 'x' ];then
   #     ret=${ret//\n/ }
        #local OLDIFS=$IFS
        #IFS='\n'
   #     for i in $ret;do
   #       position=$i  # just get the first one if have many
   #       break
   #     done
        #IFS=$OLDIFS
   #  fi
   # tmpx=$(($tmpx+1))
   #done
   ACL_LOG "start get other info for rule $target_name"
   lua /lib/access_ctl/acl_timeobj.lua $target_name
   local line_number=0
   while read -r line 
   do
      line_number=$(($line_number+1))
      [ $line_number -eq 1 ] && zone=${line}
      [ $line_number -eq 2 ] && service=${line}
      [ $line_number -eq 3 ] && src=${line}
      [ $line_number -eq 4 ] && dest=${line}
      [ $line_number -eq 5 ] && srcIf=${line}
      [ $line_number -eq 6 ] && destIf=${line}
      [ $line_number -eq 7 ] && srcIfName=${line}
      [ $line_number -eq 8 ] && destIfName=${line}
      [ $line_number -eq 9 ] && action=${line}
      [ $line_number -eq 10 ] && position=${line} 
      [ $line_number -eq 11 ] && states=${line} 
      [ $line_number -eq 12 ] && wireless_flag=${line}                      #0:no wlan, 1:src wlan, 2:dest wlan, 3: all wlan
      [ $line_number -eq 13 ] && dst_domain_flag=${line}
      [ $line_number -eq 14 ] && log=${line}
  done < /tmp/acl_rule.tmp
  
    # [ "$policy" == "ACCEPT" ] && policy="RETURN"
	([ "$destIf" == "Me" ] || [ "$destIf" == "Me_REV" ]) && destIfName="$destIf"

	json_load "$(cat $acl_device_info_file)"
	json_get_var mic_type mic_type
	[ "$mic_type" == "" ] && acl_log=1
    if [ x$log == x"1" -a x$acl_log != x"1" ];then
        log_param="--log $target_name"
    fi
    if [ x$states == 'x' ];then
        extmark=$CTMARK_DEF
    else
        case "$states" in
            *new*)
                extmark=$(($extmark + $CTMARK_NEW))
            ;;
        esac
        case "$states" in
            *related*)
                extmark=$(($extmark + $CTMARK_RELATED))
            ;;
        esac
        case "$states" in
            *established*)
                extmark=$(($extmark + $CTMARK_ESTBLISHED))
            ;;
        esac
        case "$states" in
            *invalid*)
                extmark=$(($extmark + $CTMARK_INVALID))
            ;;
        esac
    fi
    case "$action" in
        ACCEPT)
            policy=" CTSTATEMARK --ctstate-accept $extmark/$CTMARK_shift $log_param"
			policy_rev=" CTSTATEMARK --ctstate-drop $extmark/$CTMARK_shift "
        ;;
        DROP)
            policy=" CTSTATEMARK --ctstate-drop $extmark/$CTMARK_shift $log_param"
			policy_rev=" CTSTATEMARK --ctstate-accept $extmark/$CTMARK_shift "
        ;;
    esac
   ACL_LOG "stop get other info for rule $target_name extmark=$extmark $policy"
}

delete_rule()
{
	#echo "in_delete_rule" >/dev/console
	local rulename=$1
	local vnet_prefix=$2
	#local dest=$3
	local access_chain=$3
	local rulenumber=$(${vnet_prefix} iptables -w -nvL ${access_chain} --line-numbers | grep "\<${rulename}_1acl\>" | wc -l)
	if [ "x${rulenumber}" == "x0" ]; then
		# no rule exist in iptables
		ACL_LOG "no rule in iptables for $rulename"
		return 
	fi
	local firstposition=$(${vnet_prefix} iptables -w -nvL ${access_chain} --line-numbers | grep "\<${rulename}_1acl\>" | head -1 | awk '{print $1}')
	ACL_LOG " delete DEL****  position in iptables for $rulename is $firstposition"
	for i in `seq 1 ${rulenumber}`; do
		${vnet_prefix} iptables -w -D ${access_chain} ${firstposition}
	done
}

get_src_rule() 
{
	local set_src_rule=""
	local rule_acl_inner_src=$1
	local rule_acl_inner_srcIfName=$2
	local rule_acl_inner_wireless_flag=$3
	if [ "${rule_acl_inner_src:0:7}" == "country" ] || [ "${rule_acl_inner_src:0:7}" == "ctgroup" ]; then
		local src_country=${rule_acl_inner_src#*:}
		set_src_rule="-m geoip --src-cc $src_country"
	elif [ "$rule_acl_inner_src" != "" ] && [ "$rule_acl_inner_src" != "IPGROUP_ANY" ];then
		local ipset_src=${rule_acl_inner_src%_REV}
		if [ "$ipset_src" == "$rule_acl_inner_src" ]; then
			set_src_rule="-m set --match-set $ipset_src src"
		else
			set_src_rule="-m set ! --match-set $ipset_src src"
		fi
		set_src_rule="$set_src_rule,src"
		#echo "[rule_acl_inner_src]set_src_rule=$set_src_rule"
	fi
	if [ "$rule_acl_inner_srcIfName" != "" ];then
		if [ "$rule_acl_inner_wireless_flag" == "1" -o "$rule_acl_inner_wireless_flag" == "3" ]; then
			set_src_rule="-m bridgeport --multisports $rule_acl_inner_srcIfName"
		else
			local src_lan_ifname=${rule_acl_inner_srcIfName%_REV}
			if [ "$src_lan_ifname" == "$rule_acl_inner_srcIfName" ]; then
				set_src_rule="-i $src_lan_ifname"
			else
				set_src_rule="! -i $src_lan_ifname"
			fi
		fi
		#echo "[rule_acl_inner_srcIfName]set_src_rule=$set_src_rule"
	fi
	
	echo $set_src_rule
}

get_dst_rule()
{
## 这里不处理FQDN的dst_rule ##
	local set_dst_rule=""
	local rule_acl_inner_dest=$1
	local rule_acl_inner_destIfName=$2
	local rule_acl_inner_wireless_flag=$3
	if [ "${rule_acl_inner_dest:0:7}" == "country" ] || [ "${rule_acl_inner_dest:0:7}" == "ctgroup" ]; then
		local dst_country=${rule_acl_inner_dest#*:}
		set_dst_rule="-m geoip --dst-cc $dst_country"
	elif [ "$rule_acl_inner_dest" != "" ] && [ "$rule_acl_inner_dest" != "IPGROUP_ANY" ];then
		local ipset_dst=${rule_acl_inner_dest%_REV}
		if [ $ipset_dst != "Me" ];then
			if [[ "$ipset_dst" == "$rule_acl_inner_dest" ]]; then
				set_dst_rule="-m set --match-set $ipset_dst dst"
			else
				set_dst_rule="-m set ! --match-set $ipset_dst dst"
			fi
			set_dst_rule="$set_dst_rule,dst"
		fi
		#echo "[rule_acl_inner_dest]set_dst_rule=$set_dst_rule"
	fi
	
	if [ "$rule_acl_inner_destIfName" != "" ];then
		if [ "$rule_acl_inner_wireless_flag" == "2" -o "$rule_acl_inner_wireless_flag" == "3" ]; then
			set_dst_rule="-m bridgeport --multidports $rule_acl_inner_destIfName"
		else
			local dst_lan_ifname=${rule_acl_inner_destIfName%_REV}
			if [ $dst_lan_ifname != "Me" ];then
				if [ "$dst_lan_ifname" == "$rule_acl_inner_destIfName" ];then
					set_dst_rule="-o $dst_lan_ifname"
				else
					set_dst_rule="! -o $dst_lan_ifname"
				fi
			fi
		fi
		#echo "[rule_acl_inner_destIfName]set_dst_rule=$set_dst_rule"
	fi
	echo $set_dst_rule
}

add_fqdn_rule() 
{
    ## fqdn暂时仅支持IPv4 ##
	local access_ctl_chain=$1 
	local direction_rules=$2 
	local set_src_rule=$3
	local rule_acl_inner_name=$4 
	local rule_acl_inner_policy=$5 
	local rule_acl_inner_policy_rev=$6
	local service_type=$7
	local position=$8
	local dst_domains=$(uci get access_ctl.$rule_acl_inner_name.dst_domain 2>/dev/null)
	for dst_domain in ${dst_domains};do
		local num_fqdn_group=$(uci get fqdn.$dst_domain.option_nums 2>/dev/null)
		num_fqdn_group=$((num_fqdn_group))
		while [ $num_fqdn_group -ge 1 ];do
			local fqdn_ipset_name=$(uci get fqdn.$dst_domain.name_$num_fqdn_group 2>/dev/null)
			if [ $service_type == "ALL" ]; then
				local fqdn_ports_name=$(uci get fqdn.$dst_domain.port_$num_fqdn_group 2>/dev/null)
				fqdn_ports_name=$(echo $fqdn_ports_name|tr '-' ':')
				local set_dst_rule="-m set --match-set $fqdn_ipset_name dst -m multiport --dports $fqdn_ports_name"
				local set_dst_rule_rev="-m set --match-set $fqdn_ipset_name dst -m multiport ! --dports $fqdn_ports_name"
				local set_dst_rule_all="-m set --match-set $fqdn_ipset_name dst"
				# 所有支持配置port的协议：tcp/UDP/DCCP(33)/SCTP(132)/UDP-Lite(136)
				local protos="tcp udp 33 132 136"
				local protos_rev="136 132 33 udp tcp"
				local rule="$direction_rules"" ""-p tcp"" ""$set_src_rule"" ""$set_dst_rule"" ""-m comment --comment ${rule_acl_inner_name}_1acl"
				fw_check "filter" "$access_ctl_chain" "$rule -j $rule_acl_inner_policy"
				[ x$? == x0 ] && {
					if [ $position == 0 ];then
						for proto in $protos; do
							##port
							iptables -w -A $access_ctl_chain $direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment \
							${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}
							
							ACL_LOG "[FQDN rule] add rule :iptables -w -A $access_ctl_chain $direction_rules -p $proto $set_src_rule \ 
							$set_dst_rule -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}"
							
							## !port
							iptables -w -A $access_ctl_chain $direction_rules -p $proto $set_src_rule $set_dst_rule_rev -m comment \
							--comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy_rev}
							
							ACL_LOG "[FQDN rule_rev] add rule :iptables -w -A $access_ctl_chain $direction_rules -p $proto $set_src_rule \
							$set_dst_rule_rev -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy_rev}"
						done

						## ALL
						iptables -w -A $access_ctl_chain $direction_rules $set_src_rule $set_dst_rule_all -m comment --comment \
						${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}

						ACL_LOG "[FQDN rule_all] add rule :iptables -w -A $access_ctl_chain $direction_rules $set_src_rule \
						$set_dst_rule_all -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}"
					else
						## 保证以insert插入时，顺序不出错
						## ALL
						iptables -w -I $access_ctl_chain $position $direction_rules $set_src_rule $set_dst_rule_all -m comment --comment \
						${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}

						ACL_LOG "[FQDN rule_all] add rule :iptables -w -I $access_ctl_chain $position $direction_rules $set_src_rule \
						$set_dst_rule_all -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}"

						for proto in $protos_rev; do
							## !port
							iptables -w -I $access_ctl_chain $position $direction_rules -p $proto $set_src_rule $set_dst_rule_rev -m comment \
							--comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy_rev}
							
							ACL_LOG "[FQDN rule_rev] add rule :iptables -w -I $access_ctl_chain $position $direction_rules -p $proto $set_src_rule \
							$set_dst_rule_rev -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy_rev}"

							##port
							iptables -w -I $access_ctl_chain $position $direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment \
							${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}
							
							ACL_LOG "[FQDN rule] add rule :iptables -w -I $access_ctl_chain $position $direction_rules -p $proto $set_src_rule \ 
							$set_dst_rule -m comment --comment ${rule_acl_inner_name}_1acl -j ${rule_acl_inner_policy}"
						done

						
					fi
				}
			else
				if [ "$service_type" == "6" -o "$service_type" == "17" -o "$service_type" == "33" -o "$service_type" == "132" -o "$service_type" == "136" ]; then
					local fqdn_ports_name=$(uci get fqdn.$dst_domain.port_$num_fqdn_group 2>/dev/null)
					fqdn_ports_name=$(echo $fqdn_ports_name|tr '-' ':')
					local set_dst_rule="-m set --match-set $fqdn_ipset_name dst -m multiport --dports $fqdn_ports_name"
					local proto=$service_type
					local rule="$direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment ${rule_acl_inner_name}_1acl"
					fw_check "filter" "$access_ctl_chain" "$rule -j $rule_acl_inner_policy" 
					[ x$? == x0 ] && {
						if [ $position == 0 ];then
							ACL_LOG "[position 9] add rule: iptables -w -A $access_ctl_chain $rule -j ${rule_acl_inner_policy}"
							iptables -w -A $access_ctl_chain $rule -j ${rule_acl_inner_policy}
						else
							ACL_LOG "[position 10] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${rule_acl_inner_policy}"
							iptables -w -I $access_ctl_chain $position $rule -j ${rule_acl_inner_policy}
						fi
					}
				else
					local proto=$service_type
					local set_dst_rule="-m set --match-set $fqdn_ipset_name dst"
					local rule="$direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment ${rule_acl_inner_name}_1acl"
					echo "filter $access_ctl_chain $rule -j $rule_acl_inner_policy" > /dev/console
					fw_check "filter" "$access_ctl_chain" "$rule -j $rule_acl_inner_policy"
					
					[ x$? == x0 ] && {
						if [ $position == 0 ];then
							ACL_LOG "[position 11] add rule: iptables -w -A $access_ctl_chain $rule -j ${rule_acl_inner_policy}"
							iptables -w -A $access_ctl_chain $rule -j ${rule_acl_inner_policy}
						else
							ACL_LOG "[position 12] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${rule_acl_inner_policy}"
							iptables -w -I $access_ctl_chain $position $rule -j ${rule_acl_inner_policy}
						fi
					}
				fi	
			fi
			num_fqdn_group=$(($num_fqdn_group-1))
		done
	done
}

add_rule(){
	#echo "in_add_rule" >/dev/console
	local rulename=$1
    local is_delete=$2
	#local is_Me=$3
    echo "before get_other_info"
    if [ x$is_delete == 'x' ];then
		ACL_LOG "action for rule $rulename to add"
	else
		for chain in $acl_chains;do
			delete_rule ${rulename} "" $chain
		done
		ACL_LOG "action for rule $rulename to delete"
		return
	fi
	
	get_other_info $rulename
	# local service_name=$1
	# local service_proto=$2
	# local service_sport=$3
	# local service_dport=$4
	# local service_type=$5
	# local service_code=$6

	#LAN2LAN处理与VNET一致
	if [ "$zone" == "LAN2LAN" ];then
		zone="VNET"
	fi

	echo "only after log"
	#new added
	# local rulename=$7
    #end add
	#  local is_delete=$8
	local set_src_rule=""
	local set_dst_rule=""
	local LAN_INF="lan_iface"

	# if [ -n "$wireless_flag" ] && [ "$wireless_flag" != "0" ];then	#if srcIfName/destIfName is null, maybe SSID is not ready.
	# 	if [ "$delay_flag" -eq "1" ];then
	# 		if [ $wireless_flag == 1 -o $wireless_flag == 3 ]; then
	# 			srcIfName=""
	# 			for src_ssid_id in ${srcIf};do
	# 				config_load "ssid_list"
	# 				config_foreach _set_acl_srcIfName rule_ssid_info "$src_ssid_id"
	# 			done
	# 			uci set access_ctl.${rulename}.srcIfName=${srcIfName}
	# 			uci commit access_ctl
	# 		fi

	# 		if [ $wireless_flag == 2 -o $wireless_flag == 3 ]; then
	# 			destIfName=""
	# 			for dest_ssid_id in ${destIf};do
	# 				config_load "ssid_list"
	# 				config_foreach _set_acl_destIfName rule_ssid_info "$dest_ssid_id"
	# 			done
	# 			uci set access_ctl.${rulename}.destIfName=${destIfName}
	# 			uci commit access_ctl
	# 		fi
	# 	fi
	# fi

	for interface in ${zone};do
		set_src_rule=$(get_src_rule "$src" "$srcIfName" "$wireless_flag")
		set_dst_rule=$(get_dst_rule "$dest" "$destIfName" "$wireless_flag")

		local xyy="eth0"
		local access_ctl_chain=""
		local me_flag="0"
		([ "$dest" == "Me" ] || [ "$destIfName" == "Me" ]) && me_flag="1"
		[ "$me_flag" == "1" ] && access_ctl_chain="access_ctl_me"
		[ "$me_flag" != "1" ] && access_ctl_chain="access_ctl"
		local zone_in_flag=`acl_zone_in_flag $interface`
		[ $zone_in_flag == "VPN" ] && xyy=$(zone_get_wan_devices $interface)

		for device in $xyy;do
			local direction_rules=""
			[ -z "$device" ] && continue
			#direction_rules
			if [ $interface == "VNET" ];then
				direction_rules="-m set --match-set $LAN_INF src -m set --match-set $LAN_INF dst"
				[ "$me_flag" == "1" ] && direction_rules="-m set --match-set $LAN_INF src"
			elif [ $interface != "ALL" ];then
				if [ $interface == "LAN" ];then
					direction_rules="-m set --match-set $LAN_INF src -m set ! --match-set $LAN_INF dst"
					[ "$me_flag" == "1" ] && direction_rules="-m set --match-set $LAN_INF src"
				else
					[ -z "$device" ] && return
					if [ $zone_in_flag == "VPN" ];then
						direction_rules="-i $device"
					elif [ $zone_in_flag == "WAN" ];then
						direction_rules="-m set --match-set `acl_wan_zone_convert $interface` src"
					fi
				fi
			fi
			echo "direction_rules=$direction_rules"
			if [ "$service" == "ALL" ]; then #all
				if [ "$dst_domain_flag" == "1" ]; then
					add_fqdn_rule "$access_ctl_chain" "$direction_rules" "$set_src_rule" "$rulename" "$policy" "$policy_rev" "ALL" "$position"
				else
					local rule="$direction_rules"" ""$set_src_rule"" ""$set_dst_rule"" ""-m comment --comment ${rulename}_1acl"
					echo "direction_rules:$direction_rules" > /dev/console
					echo "set_src_rule:$set_src_rule" > /dev/console
					echo "set_dst_rule:$set_dst_rule" > /dev/console
					echo "rule:$rule" > /dev/console
					ACL_LOG "$rule"
					fw_check "filter" "$access_ctl_chain" "$rule -j $policy"
					[ x$? == x0 ] && {
						if [ $position == 0 ];then
							ACL_LOG "[position 5] add rule: iptables -w -A $access_ctl_chain $rule -j ${policy}"
							iptables -w -A $access_ctl_chain $rule -j ${policy}

						else
							ACL_LOG "[position 6] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${policy}"
							iptables -w -I $access_ctl_chain $position $rule -j ${policy}
		
						fi
					}
				fi
			else
				echo "enter into non-all branch"
				local SERVICE_PREFIX="service_"
				local service_item="name sport dport proto type code"
				for i in $service; do
					for j in $service_item; do
						#service_name service_sport service_dport service_proto service_type service_code
						eval $SERVICE_PREFIX$j=$(uci get service.$i.$j 2>/dev/null)
						echo "$SERVICE_PREFIX$j = `eval echo '$'$SERVICE_PREFIX$j`"
					done 
					service_name=$(echo $service_name | tr '[a-z]' '[A-Z]')
					service_proto=$(echo $service_proto | tr '[A-Z]' '[a-z]')
					if [ "$service_proto" != "icmp" ]; then
						# for UDP/TCP
						if [ "$service_proto" == "tcp" -o "$service_proto" == "udp" -o "$service_proto" == "tcp-udp" ];then 
							[ "$service_proto" == "tcp-udp" ] && service_proto="tcp udp"
							echo "service_proto=$service_proto"
							service_sport=$(echo $service_sport|tr '-' ':')
							service_dport=$(echo $service_dport|tr '-' ':')
							for proto in $service_proto; do
								local rule="$direction_rules -p $proto -m $proto --sport $service_sport --dport $service_dport \
									$set_src_rule  $set_dst_rule -m comment --comment ${rulename}_1acl"
								fw_check "filter" "$access_ctl_chain" "$rule -j ${policy}"

								[ x$? == x0 ] && {
									if [ $position == 0 ];then
										ACL_LOG "[position 7] add rule: iptables -w -A $access_ctl_chain $rule -j ${policy}"
										iptables -w -A $access_ctl_chain $rule -j ${policy}
									else
										ACL_LOG "[position 8] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${policy}"
										iptables -w -I $access_ctl_chain $position $rule -j ${policy}
									fi
								}
							done
						else  # for other
							echo "enter into proto other branch" 
							if [ "$dst_domain_flag" == "1" ]; then
								add_fqdn_rule "$access_ctl_chain" "$direction_rules" "$set_src_rule" \
								"$rulename" "$policy" "$policy_rev" "$i" "$position"
							else
								for proto in $service_proto; do
									local rule="$direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
									fw_check "filter" "$access_ctl_chain" "$rule -j $policy" 
									[ x$? == x0 ] && {
										if [ $position == 0 ];then
											ACL_LOG "[position 13] add rule: iptables -w -A $access_ctl_chain $rule -j ${policy}"
											iptables -w -A $access_ctl_chain $rule -j ${policy}
										else
											ACL_LOG "[position 14] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${policy}"
											iptables -w -I $access_ctl_chain $position $rule -j ${policy}
										fi
									}
								done	
							fi 
						fi
					else  # for icmp
						if [ "$service_name" == "ICMP_ALL" ]; then
                            local rule="$direction_rules -p $service_proto --icmp-type any $set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
							fw_check "filter" "$access_ctl_chain" "$rule -j $policy" 
							[ x$? == x0 ] && {
								if [ $position == 0 ];then
									ACL_LOG "[position 15] add rule: iptables -w -A $access_ctl_chain $rule -j ${policy}"
									iptables -w -A $access_ctl_chain $rule -j ${policy}
								else
									ACL_LOG "[position 16] add rule: iptables -w -I $access_ctl_chain $position $rule -j ${policy}"
									iptables -w -I $access_ctl_chain $position $rule -j ${policy}
								fi
							}
                        else
							local rule="$direction_rules -p $service_proto -m $service_proto --icmp-type $service_type/$service_code \
								$set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
							fw_check "filter" "$access_ctl_chain" "$rule -j $policy"
							[ x$? == x0 ] && {
								if [ $position == 0 ];then
									ACL_LOG "[position 17] add rule:  iptables -w -A $access_ctl_chain $rule -j ${policy}"
									 iptables -w -A $access_ctl_chain $rule -j ${policy}
								else
									ACL_LOG "[position 18] add rule:  iptables -w -I $access_ctl_chain $position $rule -j ${policy}"
									 iptables -w -I $access_ctl_chain $position $rule -j ${policy}
								fi
							}
                        fi
					fi
				done
			fi
		done
	done
	ACL_LOG "action for rule $rulename stop "
}

# $1=rulename  $2=is_delete $3==>zone $4==>service_name $5==>src_group $6==>dest_group $7==>policy
# $1=rulename  $2=is_delete
# if $2 is empty,means 'add'.
{
  flock 4
  if [ -n "$delay_flag" ];then
  	echo "delay_flag:$delay_flag" > /dev/console
  fi
  ACL_LOG "start add_rule $1"
  #echo "ready_in_add_rule" >/dev/console
  add_rule $1 $2
  ACL_LOG "stop add_rule $1"
  #anete conntrack -F
} 4<>/tmp/access_ctl_lock
