#!/bin/sh
. /lib/firewall/fw.sh
. /lib/zone/zone_api.sh
. /lib/access_ctl/markdef.sh

local config_file="access_ctl"
# options of access_ctl
local zone=""
local service=""
local src=""
local dest=""
local srcIf=""
local destIf=""
local srcIfName=""
local destIfName=""
local name=""
local policy=""
local position=0
local states=""
local wireless_flag=0
local extmark=0
local action=""
local acl_chains="access_ctl_me access_ctl"
ACL_LOG()
{
  t="`date +"%Y-%M-%d %H:%m:%S"`"
  echo "$t ---> $1" >> /tmp/acl_rule.log
}

fw_acl_ipset_check()
{
  #echo "argv1=$1"
  local ret=$(ipset -L|grep $1 | awk '{print $2}')

  #[ "$ret" == "$1" ] && return 0||return 1
  return 0

}

fw_check() {
  local vnet_prefix=$4
  local ret=$(${vnet_prefix} ip6tables -w -t $1 -C $2 $3 2>&1)
  [ -n "$ret" ] && return 0||return 1
}

# _set_acl_srcIfName(){
# 	local section_name="$1"
# 	local tmp_ssid_id="$2"
# 	config_get id $section_name id
# 	config_get ifname $section_name ifname
# 	if [ "$id" -eq "$tmp_ssid_id" ];then
# 		if [ -z "$srcIfName" ];then
# 			srcIfName="$ifname"
# 		else
# 			srcIfName="$srcIfName"",""$ifname"
# 		fi
# 	fi
# }

# _set_acl_destIfName(){
# 	local section_name="$1"
# 	local tmp_ssid_id="$2"
# 	config_get id $section_name id
# 	config_get ifname $section_name ifname
# 	if [ "$id" -eq "$tmp_ssid_id" ];then
# 		if [ -z "$destIfName" ];then
# 			destIfName="$ifname"
# 		else
# 			destIfName="$destIfName"",""$ifname"
# 		fi
# 	fi
# }
acl_wan_zone_convert()
{
	local num=`echo $1| sed 's/[^0-9]//g'`
	echo "ZV_W$num"
}

acl_zone_in_flag()
{
	local wan=`echo "$1" | grep "^WAN[0-9]\+$"`
	[ -n "$wan" ] && {
		echo "WAN"
		return
	}
	local vpns=`zone_get_ifaces "VPN"`
	for vpn in $vpns
	do
		if [ "$1" == "$vpn" ];then
			echo "VPN"
			return
		fi
	done
	echo "0"
}

_wan_get_l3_device_by_zone_ipv6()
{
	. /usr/share/libubox/jshn.sh 
	local zone=$1
	local interface=""
	local ret=""
	local l3_device=""
	zone=`echo "$zone" | tr 'A-Z' 'a-z'`
	interface="$zone""_v6"
	ret=`ubus call network.interface.$interface status`
	[ "$?" == 0 ] && json_load "$ret" && json_get_var l3_device l3_device
	echo "$l3_device"
}

# reversed-order,have to find the rule before the given rulename,then insert it 
get_other_info(){
  local target_name=$1
  #local loop=0
  #local result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  #while [ x$result != 'x' ];do
  #  local name=$result
  #  [ $name == $target_name ] && {
  #     zone=$(uci get access_ctl.@rule_acl_inner[$loop].zone 2>/dev/null)
  #     service=$(uci get access_ctl.@rule_acl_inner[$loop].service 2>/dev/null)
  #     src=$(uci get access_ctl.@rule_acl_inner[$loop].src 2>/dev/null)
  #     dest=$(uci get access_ctl.@rule_acl_inner[$loop].dest 2>/dev/null)
  #     policy=$(uci get access_ctl.@rule_acl_inner[$loop].policy 2>/dev/null)
  #     break
  #  }
  #  loop=$(($loop+1))
  #  result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  #done
   # as config file stores the item in a reversed order,so,we need to keep on going
  # loop=$(($loop+1))
  # result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  # while [ x$result != 'x' ];do
  #     local ret=$(iptables -w -n -L access_ctl --line-number | grep "\b${result}_1acl\b" | cut -d ' ' -f 1)
  #     if [ x"$ret" != 'x' ];then
  #        ret=${ret//\n/ }     
  #        for i in $ret;do
  #          position=$i  # just get the first if have many
  #          break
  #        done  
  #        break
  #     fi
  #    loop=$(($loop+1))
  #    result=$(uci get access_ctl.@rule_acl_inner[$loop].name 2>/dev/null)
  # done

   #local tmpx=0
   #while [ $tmpx -lt $loop ];do
   #  result=$(uci get access_ctl.@rule_acl_inner[$tmpx].name 2>/dev/null)
   #  local ret=$(iptables -n -L access_ctl --line-number | grep $result | cut -d ' ' -f 1)
   #  if [ x"$ret" != 'x' ];then
   #     ret=${ret//\n/ }
        #local OLDIFS=$IFS
        #IFS='\n'
   #     for i in $ret;do
   #       position=$i  # just get the first one if have many
   #       break
   #     done
        #IFS=$OLDIFS
   #  fi
   # tmpx=$(($tmpx+1))
   #done

   ACL_LOG "start get other info for rule $target_name"
   lua /lib/access_ctl/acl_timeobj_v6.lua $target_name
   local line_number=0
   while read -r line 
   do
      line_number=$(($line_number+1))
      [ $line_number -eq 1 ] && zone=${line}
      [ $line_number -eq 2 ] && service=${line}
      [ $line_number -eq 3 ] && src=${line}
      [ $line_number -eq 4 ] && dest=${line}
      [ $line_number -eq 5 ] && srcIf=${line}
      [ $line_number -eq 6 ] && destIf=${line}
      [ $line_number -eq 7 ] && srcIfName=${line}
      [ $line_number -eq 8 ] && destIfName=${line}
      [ $line_number -eq 9 ] && action=${line}
      [ $line_number -eq 10 ] && position=${line} 
      [ $line_number -eq 11 ] && states=${line}
	  [ $line_number -eq 12 ] && wireless_flag=${line}                      #0:no wlan, 1:src wlan, 2:dest wlan, 3: all wlan
	  [ $line_number -eq 13 ] && v6flag=${line} 
  done < /tmp/acl_rule_v6.tmp
  
    # [ "$policy" == "ACCEPT" ] && policy="RETURN"

    if [ x$states == 'x' ];then
        extmark=$CTMARK_DEF
    else
        case "$states" in
            *new*)
                extmark=$(($extmark + $CTMARK_NEW))
            ;;
        esac
        case "$states" in
            *related*)
                extmark=$(($extmark + $CTMARK_RELATED))
            ;;
        esac
        case "$states" in
            *established*)
                extmark=$(($extmark + $CTMARK_ESTBLISHED))
            ;;
        esac
        case "$states" in
            *invalid*)
                extmark=$(($extmark + $CTMARK_INVALID))
            ;;
        esac
    fi
    case "$action" in
        ACCEPT)
            policy=" CTSTATEMARK --ctstate-accept $extmark/$CTMARK_shift "
        ;;
        DROP)
            policy=" CTSTATEMARK --ctstate-drop $extmark/$CTMARK_shift "
        ;;
    esac

   ACL_LOG "stop get other info for rule $target_name extmark=$extmark $policy"
}

delete_rule()
{
  local rulename=$1
  local vnet_prefix=$2
  local rulenumber=$(${vnet_prefix} ip6tables -w -nvL access_ctl --line-numbers | grep "\<${rulename}_1acl\>" | wc -l)
  local dnsRulenumber=$(${vnet_prefix} ip6tables -w -nvL access_ctl_dns --line-numbers | grep "\<${rulename}_accept_dns\>" | wc -l)
  if [ "x${rulenumber}" == "x0" ]; then
    # no rule exist in ip6tables
    ACL_LOG "no rule in ip6tables for $rulename"
    return 
  fi
  local firstposition=$(${vnet_prefix} ip6tables -w -nvL access_ctl --line-numbers | grep "\<${rulename}_1acl\>" | head -1 | awk '{print $1}')
  ACL_LOG " delete DEL****  position in ip6tables for $rulename is $firstposition"
  for i in `seq 1 ${rulenumber}`; do
    ${vnet_prefix} ip6tables -w -D access_ctl ${firstposition}
  done

  if [ "x${dnsRulenumber}" == "x0" ]; then
    # no rule exist in ip6tables
    ACL_LOG "no dnsRule in ip6tables for $rulename"
    return 
  fi
  local firstdnsposition=$(${vnet_prefix} ip6tables -w -nvL access_ctl_dns --line-numbers | grep "\<${rulename}_accept_dns\>" | head -1 | awk '{print $1}')
  ACL_LOG "position in ip6tables for $rulename is $firstdnsposition"
  for i in `seq 1 ${dnsRulenumber}`; do
    ${vnet_prefix} ip6tables -w -D access_ctl_dns ${firstdnsposition}
  done
}

get_src_rule() 
{
	local set_src_rule=""
	local rule_acl_inner_src=$1
	local rule_acl_inner_srcIfName=$2
	local rule_acl_inner_wireless_flag=$3
	if [ "$rule_acl_inner_src" != "" ] && [ "$rule_acl_inner_src" != "IPGROUP_ANY" ];then
		local ipset_src=${rule_acl_inner_src%_REV}
		if [ "$ipset_src" == "$rule_acl_inner_src" ]; then
			set_src_rule="-m set --match-set $ipset_src src"
		else
			set_src_rule="-m set ! --match-set $ipset_src src"
		fi
		set_src_rule="$set_src_rule,src"
		#echo "[rule_acl_inner_src]set_src_rule=$set_src_rule"
	fi
	if [ "$rule_acl_inner_srcIfName" != "" ];then
		if [ "$rule_acl_inner_wireless_flag" == "1" -o "$rule_acl_inner_wireless_flag" == "3" ]; then
			set_src_rule="-m bridgeport --multisports $rule_acl_inner_srcIfName"
		else
			local src_lan_ifname=${rule_acl_inner_srcIfName%_REV}
			if [ "$src_lan_ifname" == "$rule_acl_inner_srcIfName" ]; then
				set_src_rule="-i $src_lan_ifname"
			else
				set_src_rule="! -i $src_lan_ifname"
			fi
		fi
		#echo "[rule_acl_inner_srcIfName]set_src_rule=$set_src_rule"
	fi
	echo $set_src_rule
}

get_dst_rule()
{
## 这里不处理FQDN的dst_rule ##
	local set_dst_rule=""
	local rule_acl_inner_dest=$1
	local rule_acl_inner_destIfName=$2
	local rule_acl_inner_wireless_flag=$3
	if [ "$rule_acl_inner_dest" != "" ] && [ "$rule_acl_inner_dest" != "IPGROUP_ANY" ];then
		local ipset_dst=${rule_acl_inner_dest%_REV}
		if [ $ipset_dst != "Me" ];then
			if [[ "$ipset_dst" == "$rule_acl_inner_dest" ]]; then
				set_dst_rule="-m set --match-set $ipset_dst dst"
			else
				set_dst_rule="-m set ! --match-set $ipset_dst dst"
			fi
			set_dst_rule="$set_dst_rule,dst"
		fi
		#echo "[rule_acl_inner_dest]set_dst_rule=$set_dst_rule"
	fi
	if [ "$rule_acl_inner_destIfName" != "" ];then
		if [ "$rule_acl_inner_wireless_flag" == "2" -o "$rule_acl_inner_wireless_flag" == "3" ]; then
			set_dst_rule="-m bridgeport --multidports $rule_acl_inner_destIfName"
		else
			local dst_lan_ifname=${rule_acl_inner_destIfName%_REV}
			if [ $dst_lan_ifname != "Me" ];then
				if [ "$dst_lan_ifname" == "$rule_acl_inner_destIfName" ];then
					set_dst_rule="-o $dst_lan_ifname"
				else
					set_dst_rule="! -o $dst_lan_ifname"
				fi
			fi
		fi
		#echo "[rule_acl_inner_destIfName]set_dst_rule=$set_dst_rule"
	fi
	echo $set_dst_rule
}

add_fqdn_rule() 
{
	
	####not support ipv6####
   	####do nothing####
	return 
}

add_rule(){
	#echo "in_add_rule" >/dev/console
	local rulename=$1
    local is_delete=$2
	#local is_Me=$3
    echo "before get_other_info"
    if [ x$is_delete == 'x' ];then
		ACL_LOG "action for rule $rulename to add"
	else
		for chain in $acl_chains;do
			delete_rule ${rulename} "" $chain
		done
		ACL_LOG "action for rule $rulename to delete"
		return
	fi
	
	get_other_info $rulename
	# local service_name=$1
	# local service_proto=$2
	# local service_sport=$3
	# local service_dport=$4
	# local service_type=$5
	# local service_code=$6

	#LAN2LAN处理与VNET一致
	if [ $zone == "LAN2LAN" ];then
		zone="VNET"
	fi

	echo "only after log"
	#new added
	# local rulename=$7
    #end add
	#  local is_delete=$8
	local set_src_rule=""
	local set_dst_rule=""
	local LAN_INF="lan_iface"

	# if [ -n "$wireless_flag" ] && [ "$wireless_flag" != "0" ];then	#if srcIfName/destIfName is null, maybe SSID is not ready.
	# 	if [ "$delay_flag" -eq "1" ];then
	# 		if [ $wireless_flag == 1 -o $wireless_flag == 3 ]; then
	# 			srcIfName=""
	# 			for src_ssid_id in ${srcIf};do
	# 				config_load "ssid_list"
	# 				config_foreach _set_acl_srcIfName rule_ssid_info "$src_ssid_id"
	# 			done
	# 			uci set access_ctl.${rulename}.srcIfName=${srcIfName}
	# 			uci commit access_ctl
	# 		fi

	# 		if [ $wireless_flag == 2 -o $wireless_flag == 3 ]; then
	# 			destIfName=""
	# 			for dest_ssid_id in ${destIf};do
	# 				config_load "ssid_list"
	# 				config_foreach _set_acl_destIfName rule_ssid_info "$dest_ssid_id"
	# 			done
	# 			uci set access_ctl.${rulename}.destIfName=${destIfName}
	# 			uci commit access_ctl
	# 		fi
	# 	fi
	# fi


	for interface in ${zone};do
		set_src_rule=$(get_src_rule "$src" "$srcIfName" "$wireless_flag")
		set_dst_rule=$(get_dst_rule "$dest" "$destIfName" "$wireless_flag")
		echo "set_src_rule=$set_src_rule"
		echo "set_dst_rule=$set_dst_rule"
		
		local xyy="eth0"
		local accesss_ctl_chain=""
		local me_flag="0"
		([ "$dest" == "Me" ] || [ "$destIfName" == "Me" ]) && me_flag="1"
		[ "$me_flag" == "1" ] && accesss_ctl_chain="access_ctl_me"
		[ "$me_flag" != "1" ] && accesss_ctl_chain="access_ctl"
		local zone_in_flag=`acl_zone_in_flag $interface`
		[ $zone_in_flag == "VPN" ] && xyy=$(zone_get_wan_devices $interface)

		for device in $xyy;do
			local direction_rules=""
			[ -z "$device" ] && continue
			#direction_rules
			if [ $interface == "VNET" ];then
				direction_rules="-m set --match-set $LAN_INF src -m set --match-set $LAN_INF dst"
				[ "$me_flag" == "1" ] && direction_rules="-m set --match-set $LAN_INF src"
			elif [ $interface != "ALL" ];then
				if [ $interface == "LAN" ];then
					direction_rules="-m set --match-set $LAN_INF src -m set ! --match-set $LAN_INF dst"
					[ "$me_flag" == "1" ] && direction_rules="-m set --match-set $LAN_INF src"
				else
					[ -z "$device" ] && return
					if [ $zone_in_flag == "VPN" ];then
						direction_rules="-i $device"
					elif [ $zone_in_flag == "WAN" ];then
						direction_rules="-m set --match-set `acl_wan_zone_convert $interface` src"
					fi
				fi
			fi
			echo "direction_rules=$direction_rules"
			if [ "$service" == "ALL" ]; then #all
				if [ "$dst_domain_flag" == "1" ]; then
					add_fqdn_rule $accesss_ctl_chain $direction_rules $set_src_rule $rulename $policy $policy_rev "ALL"
				else
					local rule="$direction_rules"" ""$set_src_rule"" ""$set_dst_rule"" ""-m comment --comment ${rulename}_1acl"
					ACL_LOG "$rule"
					fw_check "filter" "$accesss_ctl_chain" "$rule -j $policy"
					[ x$? == x0 ] && {
						if [ $position == 0 ];then
							ACL_LOG "[position 5] add rule: ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}"
							ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}
						else
							ACL_LOG "[position 6] add rule: ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}"
							ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}
						fi
					}
				fi
			else
				echo "enter into non-all branch"
				local SERVICE_PREFIX="service_"
				local service_item="name sport dport proto type code"
				for i in $service; do
					for j in $service_item; do
						#service_name service_sport service_dport service_proto service_type service_code
						eval $SERVICE_PREFIX$j=$(uci get service.$i.$j 2>/dev/null)
						echo "$SERVICE_PREFIX$j = `eval echo '$'$SERVICE_PREFIX$j`"
					done 
					service_name=$(echo $service_name | tr '[a-z]' '[A-Z]')
					service_proto=$(echo $service_proto | tr '[A-Z]' '[a-z]')
	
					if [ "$service_proto" != "icmp" ]; then
						# for UDP/TCP
						if [ "$service_proto" == "tcp" -o "$service_proto" == "udp" -o "$service_proto" == "tcp-udp" ];then 
							[ "$service_proto" == "tcp-udp" ] && service_proto="tcp udp"
							echo "service_proto=$service_proto"
							service_sport=$(echo $service_sport|tr '-' ':')
							service_dport=$(echo $service_dport|tr '-' ':')
							for proto in $service_proto; do
								local rule="$direction_rules -p $proto -m $proto --sport $service_sport --dport $service_dport \
									$set_src_rule  $set_dst_rule -m comment --comment ${rulename}_1acl"
								fw_check "filter" "$accesss_ctl_chain" "$rule -j ${policy}"
								[ x$? == x0 ] && {
									if [ $position == 0 ];then
										ACL_LOG "[position 7] add rule: ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}"
										ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}
									else
										ACL_LOG "[position 8] add rule: ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}"
										ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}
									fi
								}
							done
						else  # for other
							echo "enter into proto other branch"
							if [ "$rule_acl_inner_dst_domain_flag" == "1" ]; then
								if [ "$i" == "6" -o "$i" == "17" -o "$i" == "33" -o "$i" == "132" -o "$i" == "136" ]; then
									add_fqdn_rule $accesss_ctl_chain $direction_rules $set_src_rule \
									$rulename $policy $policy_rev $i
								else
									add_fqdn_rule $accesss_ctl_chain $direction_rules $set_src_rule \
									$rulename $policy $policy_rev "NONE"
								fi
							else
								for proto in $service_proto; do
									local rule="$direction_rules -p $proto $set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
									fw_check "filter" "$accesss_ctl_chain" "$rule -j $policy" 
									[ x$? == x0 ] && {
										if [ $position == 0 ];then
											ACL_LOG "[position 13] add rule: ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}"
											ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}
										else
											ACL_LOG "[position 14] add rule: ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}"
											ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}
										fi
									}
								done	
							fi 
						fi
					else  # for icmp
						if [ "$service_name" == "ICMP_ALL" ]; then
                            local rule="$direction_rules -p $service_proto --icmp-type any $set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
							fw_check "filter" "$accesss_ctl_chain" "$rule -j $policy" 
							[ x$? == x0 ] && {
								if [ $position == 0 ];then
									ACL_LOG "[position 15] add rule: ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}"
									ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}
								else
									ACL_LOG "[position 16] add rule: ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}"
									ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}
								fi
							}
                        else
							local rule="$direction_rules -p $service_proto -m $service_proto --icmp-type $service_type/$service_code \
								$set_src_rule $set_dst_rule -m comment --comment ${rulename}_1acl"
							fw_check "filter" "$accesss_ctl_chain" "$rule -j $policy"
							[ x$? == x0 ] && {
								if [ $position == 0 ];then
									ACL_LOG "[position 17] add rule:  ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}"
									 ip6tables -w -A $accesss_ctl_chain $rule -j ${policy}
								else
									ACL_LOG "[position 18] add rule:  ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}"
									 ip6tables -w -I $accesss_ctl_chain $position $rule -j ${policy}
								fi
							}
                        fi
					fi
				done
			fi
		done
	done
	ACL_LOG "action for rule $rulename stop "
}

# $1=rulename  $2=is_delete $3==>zone $4==>service_name $5==>src_group $6==>dest_group $7==>policy
# if $2 is empty,means 'add'.
{
  flock 4
  ACL_LOG "start add_rule $1"
  add_rule $1 $2 $3 $4 $5 $6 $7
  ACL_LOG "stop add_rule $1"
  #anete conntrack -F
} 4<>/tmp/access_ctl_lock
