local sys  = require "luci.sys"
local json = require 'luci.json'
local utl = require "luci.util"
local dbg  = require 'luci.tools.debug'
local form = require "luci.tools.form"
local uci  = require "luci.model.uci"
local uci_r = uci.cursor()
local SWITCH_CONFIG = "lports"

function get_phy_wan()
	local res
	local phy_wan
	uci_r:foreach(SWITCH_CONFIG, "lport",
		function(section)
			port = string.match(section['.name'], "port(%d+)")
			type = uci_r:get(SWITCH_CONFIG, "port" .. port, "p_type") or ""
			if port and type and tostring(type) == "1" then
				phy_wan = port
			end
		end)
	if phy_wan and phy_wan ~= "" then
		res = "Vlan_id, 0 express wan" .. phy_wan .. ", ex: 4093"
	else
		res = "Vlan_id, ex: 4093"
	end
	return res
end

local help_msg = get_phy_wan()
io.write(help_msg)
