local sys  = require "luci.sys"
local json = require 'luci.json'
local utl = require "luci.util"
local dbg  = require 'luci.tools.debug'
local form = require "luci.tools.form"
local uci  = require "luci.model.uci"
local error_print = require "luci.tools.error_print"
--local snmp = require 'luci.controller.admin.snmp'
local accesslist = require 'luci.controller.admin.access_ctl'
local ifs = require "luci.model.interfaces".ifs()
local CFG_PATH = "/etc/profile.d"
local uci_r = uci.cursor()

function switch_port_number()
    local swpconut = uci_r:get("lports", "global","ports_num")
    local pport = uci_r:get("lports", "global", "ports")
    local phys = uci_r:get("lports", "usb_list", "usb_name")
    local all_port_count
    local port_start = 1
    local port_end = 1
    local port_end_last = 1
    local port_range = {}
    local i_start = 1
    local i_end = 1

    if phys == nil then
        all_port_count = tonumber(swpconut)
    else
        all_port_count = #phys + tonumber(swpconut)
    end

    for i=1, all_port_count do
        if string.match(pport, "^%d+") == tostring(i) then
            port_start = i
            i_start = i
            port_end_last = i
        end
        if string.match(pport, "%d+$") == tostring(i) then
            port_end = i
            i_end = i
        end
    end

    for i=tonumber(i_start), tonumber(i_end) do
        if i < tonumber(i_end) then
            i = i+1  
        else
            break
        end
        port_num = string.match(pport, tostring(" "..i.." "))
            
        if not port_num then
            if i == tonumber(i_end) then
                if port_start == port_end then
                    port_range[#port_range+1] = tostring(port_end)
                else
                    port_range[#port_range+1] = tostring(port_start.."-"..port_end)
                end
            elseif port_end_last == port_start and port_start == i_start then
                port_range[#port_range+1] = tostring(port_start)
                port_start = i+1
                port_end_last = i+1
            elseif port_end_last == port_start and port_start ~= i_start then
                port_start = i+1
                port_end_last = i+1
            else
                port_range[#port_range+1] = tostring(port_start).."-"..tostring(port_end_last)
                port_start = i+1
                port_end_last = i+1
            end
        else
            port_end_last = i
        end
    end
    return port_range
end

function switch_port_number_2()
    local swpconut = uci_r:get("lports", "global","ports_num")
    local pport = utl.split(uci_r:get("lports", "global", "ports"), ' ')
    local ptype = utl.split(uci_r:get("lports", "global", "ptype"), ' ')
    local port_range = {}
    for i=1,swpconut do
        if tonumber(ptype[i]) ~= 3 then
            port_range[#port_range+1] = pport[i]
        end
    end
    return port_range
end

local port_range
if tonumber(arg[1]) == 1 then
    port_range = switch_port_number()
else
    port_range = switch_port_number_2()
end
local port_num_msg = ""
for i=1, #port_range do
    if i == 1 then
        port_num_msg = port_num_msg..port_range[i]
    else
        port_num_msg = port_num_msg..","..port_range[i]
    end
end
io.write("port_no type,range "..port_num_msg)
