#!/bin/sh 
. /lib/functions.sh

#para A/D srcip destip protocol srcport destport comment
#para F comment
#example nat_dmz_bypass_fivetuple.sh A 1.1.1.1 2.2.2.2 udp 80 443 voip_mdz
#example nat_dmz_bypass_fivetuple.sh F voip_mdz

method="$1"
comment="$2"
srcip="$3"
destip="$4"
protocol="$5"
srcport="$6"
destport="$7"

match_con=""
dmz_pre_rule="dmz_prerouting_rule"

_get_match_con()
{
    match_con=""
    [ -n "$srcip" ] && match_con="$match_con"" -s $srcip "
    [ -n "$destip" ] && match_con="$match_con"" -d $destip "
    [ -n "$protocol" ] && [ "x$protocol" = "xtcp" -o "x$protocol" = "xudp" ] && {
        match_con="$match_con"" -p $protocol "
        [ -n "$srcport" ] && [ "$srcport" -gt 0 ] && match_con="$match_con"" --sport $srcport "
        [ -n "$destport" ] && [ "$destport" -gt 0 ] && match_con="$match_con"" --dport $destport "
    }
}

{
    flock -x 60
    if [ -n "$method" ] && [ -n "$comment" ]; then
        if [ "x$method" = "xA" ]; then  #add
            _get_match_con
            if ! iptables -w -t nat -C $dmz_pre_rule $match_con -m comment --comment "$comment" -j RETURN 2>/dev/null; then
                iptables -w -t nat  -I $dmz_pre_rule $match_con -m comment --comment "$comment" -j RETURN
            fi
        elif [ "x$method" = "xD" ]; then  #del
            _get_match_con
            iptables -w -t nat  -D $dmz_pre_rule $match_con -m comment --comment "$comment" -j RETURN
        elif [ "x$method" = "xF" ]; then  #flush
            local iptables_rule=""
            iptables -w -t nat -S $dmz_pre_rule | grep "\b$comment\b" > /tmp/dmz_bypass_iptables
            while read line
            do
                iptables_rule=${line/-A/-D}
                iptables -w -t nat $iptables_rule
            done < /tmp/dmz_bypass_iptables
        fi
    fi
    flock -u 60
} 60<>/tmp/dmz_bypass.lock
