omada_progress_file="/www/webpages/omada_init_progress"
omada_https_port_file="/www/webpages/omada_https_port"

delete_http_iptables()
{
	local num=$1
	#echo "delete_redirect_iptables,delete redirect iptables,num:$num" > /dev/console	
	iptables -w -t nat -D PREROUTING $num
}

redirect_index_html()
{
        local index_html="/www/index.html"
        # 读取文件内容
        file_content=$(cat $index_html)

        # 删除指定字符串
        modified_content=$(echo "$file_content" | sed 's|URL=/webpages/loading.html||g')

        # 将修改后的内容写回文件
        echo "$modified_content" > $index_html
}

delete_redirect_iptables(){
        echo "omadad start_progress has reached 100. disable uhttpd." > /dev/console

        # delete uhttpd redirect iptables rule
        num=$(iptables -w -nvL -t nat --line-numbers | grep "HTTP_REDIRECT" | cut -d ' ' -f 1)
        while [ -n "$num" ]; do
                #echo "HTTP_REDIRECT iptables,num:$num" > /dev/console
                delete_http_iptables ${num}
                num=$(iptables -w -nvL -t nat --line-numbers | grep "HTTP_REDIRECT" | cut -d ' ' -f 1)
        done

        num=$(iptables -w -nvL -t nat --line-numbers | grep "HTTPS_REDIRECT" | cut -d ' ' -f 1)
        while [ -n "$num" ]; do
                #echo "HTTPS_REDIRECT iptables,num:$num" > /dev/console
                delete_http_iptables ${num}
                num=$(iptables -w -nvL -t nat --line-numbers | grep "HTTPS_REDIRECT" | cut -d ' ' -f 1)
        done

        sleep 20
        echo "uhttpd task is over,kill progress" > /dev/console
        uci -c /etc/profile.d set profile.@global[0].uhttpd_state=0
        /etc/init.d/uhttpd stop
}

set_omada_init_progress(){
        local value=$1
        
        if [ "$value" = "100" ]; then
                redirect_index_html
                echo "$value" > $omada_progress_file
                delete_redirect_iptables
        else
                echo "$value" > $omada_progress_file
        fi
}

get_omada_init_progress(){
        local value=0
        value=$(cat $omada_progress_file)
        if [ "$value" = "100" ]; then
                redirect_index_html
                delete_redirect_iptables
        fi
        echo "$value"
}

set_omada_https_port(){
        echo "$1" > $omada_https_port_file
}

# 检查是否提供了命令行参数
if [ "$#" -eq 2 ]; then
    local msg_type=$1
    local msg_value=$2
    #echo "uhttpd_omada_interface.sh,msg_type:$msg_type,msg_value:$msg_value" > /dev/console
    if [ "$msg_type" == "init_progress" ]; then
        set_omada_init_progress "$msg_value"
    fi
    if [ "$msg_type" == "https_port" ]; then
        set_omada_https_port "$msg_value"
    fi
else
    echo "uhttpd_omada_interface.sh,Usage: $0 <type> <value>" > /dev/console
fi

