local wportal = require "luci.controller.admin.wportal"
local uci = require "luci.model.uci"
local dt_m = require "luci.tools.datatypes"
local uci_r = uci.cursor()
local dbg = require "luci.tools.debug"

local function zone_get_zone_byif(t)
    local devices

    local cmd = ". /lib/zone/zone_api.sh; zone_get_iface_bydev " .. dt_m.safeSpecialString(t)
    local ff = io.popen(cmd, "r");
    if not ff then
        return devices
    end

    local if_eth = ff:read("*l")
    if not if_eth then
        ff:close()
        return devices
    end
    ff:close()
    ff=nil

    local cmd = ". /lib/zone/zone_api.sh; zone_get_zone_byif " .. dt_m.safeSpecialString(if_eth)
    local ff = io.popen(cmd, "r");
    if not ff then
        return devices
    end

    local zone = ff:read("*l")
    if not zone then
        ff:close()
        return devices
    end
    ff:close()

    return zone
end

local function Whether_to_support_wireless()
    local wireless_support = uci_r:get_profile("global", "support_wireless")  or 0
    if wireless_support == 1 then
        return true
    else 
        return false
    end
end

--allow authserver in private and guest network
if Whether_to_support_wireless() then
    local port = uci_r:get("wportal", "global_set", "auth_port") or '8080'
    local external_url = uci_r:get("wportal", "dft_wportal", "external_url") or ''
    local wportal_page_type = uci_r:get("wportal", "dft_wportal", "wportal_page_type") or 'local'
    local wportal_config = wportal.get_wportal()
    local ssid = wportal_config.ssid
    local zone = wportal_config.zones
    local external_url,url_port = wportal.external_url_split(external_url)

    if ssid and port then
        wportal.send_ip_port_to_wireless(ssid, port, zone)
        if wportal_page_type == "remote" then
            wportal.send_external_ip_port_to_wireless(external_url, url_port)
        end
    end
end