# Copyight(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     zone_api.sh
# bief     The Api for zone
# author   Yuan Fengjia
# vesion   1.0.0
# history  1.0.0, 13May15, Yuanfengjia, Ceate the file
. /lib/zone/zone_api_core.sh
ZONE_FILE_LOCK=/tmp/zone.file.lock

#Get all zone int system
zone_get_zonelist() {
	echo "`zone -F zone_get_user_zonelist`"
}

#Get interfaces(netifd) by one zone 
zone_get_ifaces() {
	echo "`zone -F zone_get_ifaces -P $1`"
}

#Get wan interfaces(netifd) by one zone or interface
zone_get_wan_ifaces() {
	echo "`zone -F zone_get_wan_ifaces -P $1`"
}

#Get effect main wan interfaces(netifd) by one zone
zone_get_effect_main_wan_ifaces() {
	echo "`zone -F zone_get_effect_main_wan_ifaces -P $1`"
}

zone_generage_ifaces_env() {
	local if_list=""
	local zone_list=`zone -F zone_get_user_zonelist`

	for zone in ${zone_list};do
		ifaces=`zone -F zone_get_effect_ifaces -P ${zone}`
		[ -n "$ifaces" ] && if_list="$if_list $ifaces"
    done
	echo ${if_list}
}

#Get effect interfaces(netifd) by one zone or interface
zone_get_effect_ifaces() {
	echo "`zone -F zone_get_effect_ifaces -P $1`"
}

#Get all devices(netifd) by one zone 
zone_get_devices() {
	echo "`zone -F zone_get_devices -P $1`"
}

#Get device by zone
zone_get_device() {
	iface=`zone -F zone_get_effect_ifaces -P $1`
	echo "`zone -F zone_get_device_byif -P $iface`"
}

#Get wan effect devices(netifd) by one zone or interface
zone_get_wan_devices() {
	echo "`zone -F zone_get_wan_devices -P $1`"
}

#Get main wan effect devices by one zone
zone_get_effect_main_wan_devices() {
	echo "`zone -F zone_get_effect_main_wan_devices -P $1`"
}

#Get all effect devices(netifd) by one zone or interface
zone_get_effect_devices() {
	echo "`zone -F zone_get_effect_devices -P $1`"
}

#Get the device by one interface
zone_get_device_byif() {
	echo "`zone -F zone_get_device_byif -P $1`"
}

#Get the interface by one device(tmp,just for ipsec)
zone_get_iface_bydev() {
	echo "`zone -F zone_get_iface_bydev -P $1`"
}

#Get the zone by one interface.
zone_get_zone_byif() {
	echo "`zone -F zone_get_zone_byif -P $1`"
}

#Get the iface state by one device.state:UP,DOWN
zone_get_iface_state() {
	echo "`zone -F zone_get_iface_state -P $1`"
}

#Get VPN interface list
zone_get_vpn_ifaces() {
	echo "`zone -F zone_get_vpn_ifaces`"
}

#Get VPN device list
zone_get_vpn_devices() {
	echo "`zone -F zone_get_vpn_devices`"
}

#Get NORMAL interface list
zone_get_normal_ifaces() {
	echo "`zone -F zone_get_normal_ifaces`"
}

#Get NORMAL device list
zone_get_normal_devices() {
	echo "`zone -F zone_get_normal_devices`"
}

zone_check_if_effect()
{
	local ret=`zone -F zone_check_if_effect -P $1`
	echo "$ret"
	[ "$ret" == "0" ] && return 0
	return 1
}

zone_check_dev_effect()
{
	local ret=`zone -F zone_check_dev_effect -P $1`
	echo "$ret"
	[ "$ret" == "0" ] && return 0
	return 1
}

#Get ethernet device by one interface
zone_get_eth_device() {
	echo "`zone -F zone_get_eth_device -P $1`"
}

#Get the zone by one interface.
zone_get_zone_by_device() {
	local ret=`zone -F zone_get_zone_by_device -P $1`
	echo "$ret"
	[ "$ret" == "" ] && return 1
	return 0
}

#check VPN interface
zone_check_vpn_interface() {
	local ret=`zone -F zone_check_vpn_interface -P $1`
	echo "$ret"
	[ "$ret" == "true" ] && return 0
	return 1
}

#Get VPN interface by device name
#zone_get_vpn_
zone_test() {
    local zonelist=$(zone_get_zonelist)
    echo "zonelist=$zonelist"
    
    local ifaces=$(zone_get_ifaces "WAN3")
    echo "ifaces=$ifaces"
    
    local effect_ifaces=$(zone_get_effect_ifaces "WAN1")
    echo "effect_ifaces=$effect_ifaces"
    
    local devices=$(zone_get_devices "WAN3")
    echo "devices=$devices"
    
    local effect_devices=$(zone_get_effect_devices "wan1_eth")
    echo "effect_devices=$effect_devices"
    
    local device=$(zone_get_device_byif "wan3_eth")
    echo "device=$device"
    
    local iface=$(zone_get_iface_bydev "inf.4094")
    echo "iface=$iface"
    
    local zone=$(zone_get_zone_byif "wan1_eth")
    echo "zone=$zone"
    
    local state=$(zone_get_iface_state "wan3_eth")
    echo "state=$state"
    
    local vpn_ifaces=$(zone_get_vpn_ifaces)
    echo "vpn_ifaces=$vpn_ifaces"
    
    local vpn_devices=$(zone_get_vpn_devices)
    echo "vpn_devices=$vpn_devices"
	
	local normal_ifaces=$(zone_get_normal_ifaces)
    echo "normal_ifaces=$normal_ifaces"
    
    local normal_devices=$(zone_get_normal_devices)
    echo "normal_devices=$normal_devices"
}
