# Copyight(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     zone_conf.sh
# bief     Config the zone info
# author   Yuan Fengjia
# vesion   1.0.0
# history  1.0.0, 13May15, Yuanfengjia, Ceate the file

. /lib/functions.sh
. /lib/functions/network.sh
. /lib/zone/zone_conf.sh
. /lib/zone/zone_init.sh
include /lib/network
. /lib/zone/zone_init_all.sh

ZONE_STATE=${ZONE_STATE:=zone}

zone_main() {
    config_load zone
    uci_revert_state $ZONE_STATE
    uci_set_state $ZONE_STATE core "" zone_state
    
    zone_config
}

zone_start() {
  zone_main
}

zone_stop() {
    uci_revert_state $ZONE_STATE
}

zone_restart() {
    zone_start
}

zone_del_zone() {
    local creator=

    zone_del_zone_state "$1"
    creator=$(uci get zone.$1.creator)
    if [ "$creator" != "vnet" ]; then
        zone_conf_clean_spec "$1"
    else
        uci_remove zone "$1"
        uci_commit zone
    fi
}

zone_add_zone() {
    local iface=

    iface=$(vnet_get_iface_byzone "$1")
    if [ -z "$iface" ]; then
        zone_conf_build_spec "$1"
    else
        vnet_build_a_interface_ "$iface"
        uci_commit zone
    fi
    zone_add_zone_state "$1"
}

zone_update_zone() {
    zone_del_zone "$1"
    zone_add_zone "$1"
}
