# Copyight(c) 2008-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     zone_init.sh
# bief     Config the zone info
# author   Yuan Fengjia
# vesion   1.0.0
# history  1.0.0, 13May15, Yuanfengjia, Ceate the file

. /lib/pppox/pppox-wheader.sh

singlewan=0
wanmax=4
WAN1=WAN1

ZONE_REBUILD_LOCK="/tmp/.zone_rebuild_lock"

scan_interfaces() {
	local config="$1"
	local ifname type device proto t_poe_enable 

	#echo "config=$config"

	config_get type "$config" type
	#echo "type=$type"

	config_get ifname "$config" ifname
	#echo "ifname=$ifname"

	config_get device "$config" device "$ifname"
	#echo "device=$device"

	config_get proto "$config" proto
	#echo "proto=$proto
    config_get logical_name "$config" logical_name
    #逻辑wan单独处理，zone名称为WAN${wan_id}_${conn_id},如WAN1_1
    if [ "$logical_name" ]; then
        config_get wan_id "$config" wan_id
        config_get conn_id "$config" conn_id

        [ "static" == "$proto" ] || [ "dhcp" == "$proto" ] && {

            if [ -n "$ifname" -a -n "$device" ]; then
                device="$ifname"
            fi
            #uci delete zone.WAN${wan_id}_${conn_id}
            uci set zone.WAN${wan_id}_${conn_id}=zone
            uci_set zone "WAN${wan_id}_${conn_id}" if_eth "$config"
            uci_set zone "WAN${wan_id}_${conn_id}" dev_eth "$device"
            uci_set zone "WAN${wan_id}_${conn_id}" conn_id "$conn_id"
            uci_commit zone

            . /lib/zone/zone_conf.sh
            local zone_all_set=$(_zone_gname "$(global_wan_name_list)")
            local gname="$(_zone_gname WAN${wan_id}_${conn_id})"
   
            ipset create "$gname" hash:iface

            ipset add $zone_all_set $gname
            return 
	    }
        config_get t_poe_enable  "$config" t_poe_enable 
        [ "pppoe" == "$proto" -a "1" == "$t_poe_enable" ] && {

            #uci delete zone.WAN${wan_id}_${conn_id}
            #echo "wan${i} pppoe interafce" >> /dev/console
            uci set zone.WAN${wan_id}_${conn_id}=zone
            uci_set zone "WAN${wan_id}_${conn_id}" if_1 "$config"
            uci_set zone "WAN${wan_id}_${conn_id}" dev_1 ${pppoe_header}${config}
            uci_set zone "WAN${wan_id}_${conn_id}" conn_id "$conn_id"
            uci_commit zone
            
            . /lib/zone/zone_conf.sh
            local zone_all_set=$(_zone_gname "$(global_wan_name_list)")
            local gname="$(_zone_gname WAN${wan_id}_${conn_id})"
   
            ipset create "$gname" hash:iface

            ipset add $zone_all_set $gname
         
            return
        }
        return 
    fi
	local wan_id=`echo $config | tr -cd "[0-9]"`

	[ "lan" == "$config" ] && {
		uci_set zone LAN if_eth lan
		uci_set zone LAN dev_eth br-lan
		uci_commit zone
		return
	}
	
	[ "static" == "$proto" ] || [ "dhcp" == "$proto" ] || [ "mobile" == "$proto" ] && {
		#echo "eth interafce"
		if [ "$type" == "bridge" ]; then
			device="br-$config"
		elif [ -n "$ifname" -a -n "$device" ]; then
			device="$ifname"
		fi

		[ "wan${wan_id}_eth" == "$config" ] && {
			#echo "wan${wan_id} eth interafce" >> /dev/console
			uci_set zone "WAN${wan_id}" if_eth "$config"
			uci_set zone "WAN${wan_id}" dev_eth "$device"
			uci_commit zone
		}
		return
	}

	config_get t_poe_enable  "$config" t_poe_enable 
	[ "pppoe" == "$proto" -a "1" == "$t_poe_enable" ] && {
		#echo "pppoe interafce"
		[ "wan${wan_id}_poe" == "$config" ] && {
			#echo "wan${i} pppoe interafce" >> /dev/console
			uci_set zone "WAN${wan_id}" if_1 "$config"
			uci_set zone "WAN${wan_id}" dev_1 ${pppoe_header}${config}
			uci_commit zone
		}
		return
	}
  
	[ "pptp" == "$proto" -a "1" == "$t_poe_enable" ] && {
		#echo "pptp interafce"
		[ "wan${wan_id}_poe" == "$config" ] && {
			#echo "wan${i} pptp interafce" >> /dev/console
			uci_set zone "WAN${wan_id}" if_1 "$config"
			uci_set zone "WAN${wan_id}" dev_1 ${pptp_header}${config}
			uci_commit zone
		}
		return
	}
  
	[ "l2tp" == "$proto" -a "1" == "$t_poe_enable" ] && {
		#echo "l2tp interafce"
		[ "wan${wan_id}_poe" == "$config" ] && {
			#echo "wan${i} l2tp interafce" >> /dev/console
			uci_set zone "WAN${wan_id}" if_1 "$config"
			uci_set zone "WAN${wan_id}" dev_1 ${l2tp_header}${config}
			uci_commit zone
		}
		return
	}
	[ -n "$proto" -a "none" != "$proto" ] && {
		[ "wan${wan_id}_eth" == "$config" -o "wan${wan_id}_poe" == "$config" ] && {
			echo "error! zone_init_all: interface ${config} proto ${proto} doesn't match any proto." >> /dev/console
		}
	}
}

scan_l2tp_interfaces() {
    local lac="$1"
    local tunnelname=""
   
    config_get tunnelname "$lac" tunnelname
    [ -n "$tunnelname" ] && {
        uci set zone.$tunnelname=iface
        uci_set zone $tunnelname iface "$tunnelname"
        uci_set zone $tunnelname dev "lt-${tunnelname}"
        uci_add_list zone VPN iface $tunnelname
        uci_commit zone
    }
}

scan_pptp_interfaces() {
    local pnc="$1"
    local tunnelname=""
    
    config_get tunnelname "$pnc" tunnelname
    [ -n "$tunnelname" ] && {
        uci set zone.$tunnelname=iface
        uci_set zone $tunnelname iface "$tunnelname"
        uci_set zone $tunnelname dev "pt-${tunnelname}"
        uci_add_list zone VPN iface $tunnelname
        uci_commit zone
    }
}

scan_openvpn_interfaces() {
    local client="$1"
    local name=""
    local dev=""

    name="ovpn$client"
    config_get dev "$client" dev
    [ -n "$name" ] && {
        uci set zone.$name=iface
        uci_set zone $name iface "$name"
        uci_set zone $name dev "$dev"
        uci_add_list zone VPN iface $name
        uci_commit zone
    }
}

scan_gre_interfaces() {
    local conn="$1"
    local name=""
    local id=""
   
    config_get name "$conn" name
    config_get id "$conn" id
    [ -n "$name" ] && {
        uci set zone.$name=iface
        uci_set zone $name iface "$name"
        uci_set zone $name dev "X_gre_$id"
        uci_add_list zone VPN iface $name
        uci_commit zone
    }
}

scan_wg_interfaces() {
    local wg="$1"
    local name=""
    local id=""
   
    config_get name "$wg" name
    config_get id "$wg" id
    [ -n "$name" ] && {
        uci set zone.$name=iface
        uci_set zone $name iface "$name"
        uci_set zone $name dev "wg$id"
        uci_add_list zone VPN iface $name
        uci_commit zone
    }
}


zone_conf_clean() {
  uci -q delete zone.LAN
  for i in $(seq 1 1 $wanmax)
  do
	uci -q delete zone.WAN$i
  done

  local ifaces=""                              
  config_load zone                             
  config_get ifaces VPN iface                                            
  for i in $ifaces                                           
  do                                                                                                   
      uci delete zone.$i                                     
  done                                                                                      
  uci -q delete zone.VPN                       
                                               
  uci set zone.LAN=zone                                                   
  for i in $(seq 1 1 $wanmax)
  do
    uci set zone.WAN${i}=zone
  done
  uci set zone.VPN=zone                             
  uci_commit zone    
}

zone_logical_wan_clean() {
	wan_num=$(uci get network.global.wan_numbers)
	logical_num=$(uci -c /etc/profile.d get profile.@global[0].logywan_num)
	[ -z "$logical_num" ] && logical_num=3
	for i in $wan_num; do
		for j in $(seq 1 $logical_num); do
			uci -q delete zone.WAN${i}_${j}
			#echo "!!!! $i, $j" >> /dev/console
		done
	done                          
	uci_commit zone
}

zone_conf_build() {
  wanmax=$(uci -c /etc/profile.d get profile.@interface[0].wan_max)
  [ "$wanmax" == "" ] && wanmax=4
  {
    flock -x 71
    zone_conf_clean
    zone_logical_wan_clean
  
    config_load network
    config_foreach scan_interfaces interface
    flock -u 71
  } 71<>${ZONE_REBUILD_LOCK}
  
  #scan VPN interface
  config_load l2tp-client
  config_foreach scan_l2tp_interfaces lac
  
  config_load pptp-client
  config_foreach scan_pptp_interfaces pnc

  config_load openvpn
  config_foreach scan_openvpn_interfaces client
  config_foreach scan_openvpn_interfaces server

  config_load gre
  config_foreach scan_gre_interfaces conn

  config_load wireguard_interface
  config_foreach scan_wg_interfaces wg
}

zone_conf_find_zone() {
    local config="$1"
    local zone_name="$2"
    local logical_name=

    config_get logical_name "$config" logical_name
    if [ -n "$logical_name" ]; then
        local wan_id=
        local conn_id=
        config_get wan_id "$config" wan_id
        config_get conn_id "$config" conn_id
        [ "$zone_name" == "WAN${wan_id}_${conn_id}" ] && scan_interfaces "$config"
    else
        local wan_id=`echo $config | tr -cd "[0-9]"`
        [ "$zone_name" == "WAN${wan_id}" ] && scan_interfaces "$config"
    fi
}

#参考zone_conf_clean
zone_conf_clean_spec() {
    local zone_name="$1"
    if [ "$zone_name" == "VPN" ]; then
        local ifaces=""
        ifaces=$(uci_get zone.VPN.iface)
        for i in $ifaces
        do
            uci delete zone.$i
        done
        uci -q delete zone.VPN
        uci set zone.VPN=zone
    else
        uci -q delete zone.$zone_name
        uci set zone.$zone_name=zone
    fi
    uci_commit zone
}

#参考zone_conf_build
zone_conf_build_spec() {
    local zone_name="$1"
    if [ "$zone_name" == "VPN" ]; then
        #scan VPN interface
        config_load l2tp-client
        config_foreach scan_l2tp_interfaces lac

        config_load pptp-client
        config_foreach scan_pptp_interfaces pnc

        config_load openvpn
        config_foreach scan_openvpn_interfaces client
        config_foreach scan_openvpn_interfaces server

        config_load gre
        config_foreach scan_gre_interfaces conn

        config_load wireguard_interface
        config_foreach scan_wg_interfaces wg

    elif [ "$zone_name" == "SDWAN" ]; then
        config_load nhrp
        config_foreach scan_sdwan_interfaces nhrp_cfg

    else
        config_load network
        config_foreach zone_conf_find_zone interface "$zone_name"
    fi
}