#!/bin/sh

. /lib/functions.sh

num2ip()
{
    num=$1
    a=$((num>>24&0xff))
    b=$((num>>16&0xff))
    c=$((num>>8&0xff))
    d=$((num&0xff))
 
    echo "$a.$b.$c.$d"
}

ip2num()
{
    ip=$1
    a=`echo $ip | awk -F'.' '{print $1}'`
    b=`echo $ip | awk -F'.' '{print $2}'`
    c=`echo $ip | awk -F'.' '{print $3}'`
    d=`echo $ip | awk -F'.' '{print $4}'`
 
    echo "$(((a<<24)+(b<<16)+(c<<8)+d))"
}

add_rule()
{
    uci_add remote_mngt rsa_rule "$1"
    uci_set remote_mngt "$1" ipaddr "$2/$3"
    uci_set remote_mngt "$1" enabled "on"
    uci_set remote_mngt "$1" edit "off"
    uci_commit remote_mngt
}

del_rule()
{
    uci_remove remote_mngt "$1"
    uci_commit remote_mngt
}

add_openvpn_remote_management()
{
    start=$1
    end=$2
    pname=$3
    s=$(ip2num "$start")
    e=$(ip2num "$end")
    m=0xFFFFFFFF

    while [ $((${s} & ${m})) -ne $((${e} & ${m})) ];
    do
        m=$((${m}<<1))
    done

    ip=$(num2ip $((${s} & ${m})))
    mask=0
    while [ $((${m} & 0xFFFFFFFF)) -ne 0 ];
    do
        mask=$((${mask}+1))
        m=$((${m}<<1))
    done


    add_rule $3 $ip $mask
    /etc/init.d/remote_mngt reload 2>&1 | tee /tmp/test.log
}

rm_openvpn_remote_management()
{
    pname=$1

    del_rule $pname
    /etc/init.d/remote_mngt reload 2>&1 | tee /tmp/test.log
}